io.socket.transports = ["websocket"];



// raychat local Storage Manager
var raychat_local_storage = { raychat: {} };
raychat_local_storage.init = function () {
    if (!localStorage.getItem('www.raychat.io')) {
        localStorage.setItem('www.raychat.io', JSON.stringify({}));
        if (localStorage.getItem('rayToken')) {
            this.setItem('rayToken', localStorage.getItem('rayToken'))
        }

    } else {

        this.raychat = JSON.parse(localStorage.getItem('www.raychat.io'));
    }
};
raychat_local_storage.getItem = function (key) {

    return this.raychat[key];
};
raychat_local_storage.setItem = function (key, value) {
    this.raychat[key] = value;
    this.update();
};
raychat_local_storage.update = function () {
    return localStorage.setItem('www.raychat.io', JSON.stringify(this.raychat));

};
raychat_local_storage.getObject = function () {
    return this.raychat;
};
raychat_local_storage.remove = function (key) {
    delete this.raychat[key];
    this.update();
};
raychat_local_storage.removeAll = function () {
    this.raychat = {};
    this.update();
};
raychat_local_storage.init();
raychat_local_storage.setItem('raychat_channel_photo', JSON.parse(document.getElementById('raychat_scripts').getAttribute('widget')).channelPhoto);

var widget = JSON.parse(document.getElementById('raychat_scripts').getAttribute('widget'));



io.socket.on('disconnect', function () {
    document.getElementById('raychat_main_textarea').disabled = true;
    document.getElementById('raychat_main_textarea').placeholder = widget.lang.disconnectedFromServer;
    raychat_avoid_sending(true);
});

var tryConnect = 0;
var visitorDetailsComplete = false
var checkUserInterval;
var currentForm = {};

var checkForVisitorDetails = function () {
    if (visitorDetailsComplete) {

        // do stuff
        if (raychat_local_storage.getItem('rayToken')) {

            var addToRoomData = {
                user: {
                    id: raychat_local_storage.getItem('rayToken'),
                    name: raychat_local_storage.getItem('clientName'),
                    agent: raychat_local_storage.getItem('agent'),
                    chatCount: raychat_local_storage.getItem('chatCount'),
                    href: window.location.href,
                    channelId: widget.channel.id,
                    containerId: widget.container.id
                }
            }




            io.socket.post(pubsub + '/socket/onlyAddToRoom', addToRoomData, function (resData, jwres) { })
        }
        clearInterval(checkUserInterval)


    } else {
        // waiting for response /newVisitor
    }
}

io.socket.on('connect', function () {


    checkUserInterval = setInterval(function () {
        checkForVisitorDetails()
    }, 2000)



    if (isUserLock) {
        raychat_avoid_sending(true);
        document.getElementById('raychat_main_textarea').disabled = true;
        document.getElementById('raychat_main_textarea').placeholder = widget.lang.pleaseFillForm;
        document.getElementById('raychat_main_textarea').className += " force_for_fill_form";

    } else {
        if (tryConnect === 0) {
            raychat_avoid_sending(true);
            document.getElementById('raychat_main_textarea').disabled = true;
            document.getElementById('raychat_main_textarea').placeholder = widget.lang.fetchingYourConversation;
        } else {
            raychat_avoid_sending(false);
            document.getElementById('raychat_main_textarea').disabled = false;
            document.getElementById('raychat_main_textarea').placeholder = widget.lang.sendMessage;
        }
    }


    tryConnect++;
});







var nVer = navigator.appVersion,
    nAgt = navigator.userAgent,
    browserName = navigator.appName,
    fullVersion = "" + parseFloat(navigator.appVersion),
    majorVersion = parseInt(navigator.appVersion, 10),
    nameOffset,
    verOffset, ix;
(verOffset = nAgt.indexOf("Opera")) != -1 ? (browserName = "Opera", fullVersion = nAgt.substring(verOffset + 6), (verOffset = nAgt.indexOf("Version")) != -1 && (fullVersion = nAgt.substring(verOffset + 8))) : (verOffset = nAgt.indexOf("MSIE")) != -1 ? (browserName = "Microsoft Internet Explorer", fullVersion = nAgt.substring(verOffset + 5)) : (verOffset = nAgt.indexOf("Chrome")) != -1 ? (browserName = "Chrome", fullVersion = nAgt.substring(verOffset + 7)) : (verOffset = nAgt.indexOf("Safari")) != -1 ? (browserName = "Safari", fullVersion = nAgt.substring(verOffset + 7), (verOffset = nAgt.indexOf("Version")) != -1 && (fullVersion = nAgt.substring(verOffset + 8))) : (verOffset = nAgt.indexOf("Firefox")) != -1 ? (browserName = "Firefox", fullVersion = nAgt.substring(verOffset + 8)) : (nameOffset = nAgt.lastIndexOf(" ") + 1) < (verOffset = nAgt.lastIndexOf("/")) && (browserName = nAgt.substring(nameOffset, verOffset), fullVersion = nAgt.substring(verOffset + 1), browserName.toLowerCase() == browserName.toUpperCase() && (browserName = navigator.appName)), (ix = fullVersion.indexOf(";")) != -1 && (fullVersion = fullVersion.substring(0, ix)), (ix = fullVersion.indexOf(" ")) != -1 && (fullVersion = fullVersion.substring(0, ix)), majorVersion = parseInt("" + fullVersion, 10), isNaN(majorVersion) && (fullVersion = "" + parseFloat(navigator.appVersion), majorVersion = parseInt(navigator.appVersion, 10));

function detectmob() {
    return !!(navigator.userAgent.match(/Android/i) || navigator.userAgent.match(/webOS/i) || navigator.userAgent.match(/iPhone/i) || navigator.userAgent.match(/iPad/i) || navigator.userAgent.match(/iPod/i) || navigator.userAgent.match(/BlackBerry/i) || navigator.userAgent.match(/Windows Phone/i))
}

var OSName = "Unknown OS";
navigator.appVersion.indexOf("Win") != -1 && (OSName = "Windows"), navigator.appVersion.indexOf("Mac") != -1 && (OSName = "MacOS"), navigator.appVersion.indexOf("X11") != -1 && (OSName = "UNIX"), navigator.appVersion.indexOf("Linux") != -1 && (OSName = "Linux");


var opened = false;
var openedEmoji = false;
var isUserLock = false;


var allowForScrollToFetchMore = false;
var totalChatCount = 0;
var renderedChatCount = 0;
var renderedPage = 1;

var q = document.getElementById('raychat_main_container_footer_details_div_emoji_div');
var d = document.getElementById("raychatMainContainer");
var b = document.getElementById("raychat_main_button_id");
var f = document.getElementById('raychat_main_container_footer');
var i = document.getElementById('raychat_main_textarea');
var h = document.getElementById('raychat_main_container_footer_details_div_send');
var s = document.getElementById('raychat_main_container_body');
var c = document.getElementById('raychat_main_button_count');
var u = document.getElementById('raychat_main_button_count_s');


var a = document.getElementById('raychat_main_container_body_chat_item_toast_message');
var o = document.getElementById('raychat_main_container_header_agents_accepted');
var l = document.getElementById('raychat_main_container_header_agents');
var x = document.getElementById('raychat_main_container_header_agents_accepted');
var w = document.getElementById('raychage_file_upload');
var m = document.getElementById('raychat_main_spinner');
var t = document.getElementById('raychat_main_container_body_chat_item_typing');


var g = document.getElementById('raychat_user_more_details_response');
var uu = document.getElementById('raychat_main_container_header_agents_close_btnId');
var uu2 = document.getElementById('raychat_main_container_header_agents_close_btnId2');
var rr = document.getElementById('raychat_accepted_user_title');
var ww = document.getElementById('raychat_main_container_body_watermark');
var webAppUrl = document.getElementById('raychat_scripts').getAttribute('webAppUrl');
var pubsub = document.getElementById('raychat_scripts').getAttribute('pubsub');
var cdnUrl = document.getElementById('raychat_scripts').getAttribute('cdnUrl') + "/";
var raychat_pending_for_automessage = true;

var raychat_submit_sound = document.createElement('audio');
raychat_submit_sound.setAttribute('src', webAppUrl + '/widget/audio/submit.9b6dc5c5.mp3');

var raychat_delivered_sound = document.createElement('audio');
raychat_delivered_sound.setAttribute('src', webAppUrl + '/widget/audio/delivered.240b316e.mp3');

var raychat_new_message_sound = document.createElement('audio');
raychat_new_message_sound.src = webAppUrl + '/widget/audio/notification.0d062b33.mp3'


// var oldTitle = window.parent.document.title;
var raychat_tmp_file_size;








var n;
var counter = 0;

Element.prototype.remove = function () {
    this.parentElement.removeChild(this);
};
NodeList.prototype.remove = HTMLCollection.prototype.remove = function () {
    for (var i = this.length - 1; i >= 0; i--) {
        if (this[i] && this[i].parentElement) {
            this[i].parentElement.removeChild(this[i]);
        }
    }
};


var tdata = { token: document.getElementById('raychat_scripts').getAttribute('token') };
tdata.href = window.location.href;
if (raychat_local_storage.getItem("rayToken")) {
    tdata.id = raychat_local_storage.getItem("rayToken")
}
var iphoneMode = false;

function raychat_responsive_in_iphone_open() {

    if (navigator.platform == 'iPhone' || navigator.platform == 'iPad') {

        var dHeight = d.clientHeight
        var headerHeight = document.getElementsByClassName('raychat_main_container_header')[0].clientHeight
        var footerHeight = f.clientHeight

        f.style.height = 70 + "%"


        document.getElementsByClassName('raychat_main_container_footer_details_div_emoji')[0].style.display = "none"
        document.getElementsByClassName('raychat_main_container_footer_details_div_close_type')[0].style.display = "inline-block"
        document.getElementsByClassName('raychat_main_container_footer_details_div_close_type')[0].style.backgroundPosition = "center center"
        document.getElementsByClassName('raychat_main_container_footer_details_div_close_type')[0].style.width = "49%"





        document.getElementsByClassName('raychat_main_container_footer_input_div')[0].style.width = "100%"
        document.getElementsByClassName('raychat_main_container_footer_input_div')[0].style.height = "auto"
        i.style.position = "relative"

        document.getElementsByClassName('raychat_main_container_footer_details_div')[0].style.width = "100%"

        document.getElementsByClassName('raychat_main_container_footer_details_div_send')[0].style.width = "49%"

        document.getElementsByClassName('custom-file-upload')[0].style.width = "100%"


        var footerActualHeight = (d.clientHeight * parseFloat(f.style.height)) / 100
        raychat_check_responsive(footerActualHeight)
        iphoneMode = true;








    }
}


function raychat_responsive_in_iphone_close() {
    f.style.height = 61 + "px"


    document.getElementsByClassName('raychat_main_container_footer_details_div_emoji')[0].style.display = "inline-block"
    document.getElementsByClassName('raychat_main_container_footer_details_div_close_type')[0].style.display = "none"
    document.getElementsByClassName('raychat_main_container_footer_details_div_close_type')[0].style.backgroundPosition = "center left"






    document.getElementsByClassName('raychat_main_container_footer_input_div')[0].style.width = "80%"
    document.getElementsByClassName('raychat_main_container_footer_input_div')[0].style.height = "100%"
    i.style.position = "relative"

    document.getElementsByClassName('raychat_main_container_footer_details_div')[0].style.width = "20%"

    document.getElementsByClassName('raychat_main_container_footer_details_div_send')[0].style.width = "38px"

    document.getElementsByClassName('custom-file-upload')[0].style.width = "40px"



    raychat_check_responsive(61) // refer to => f.style.height

}

function raychat_floating_app_widget_init(entity) {


    parent.raychat_check_for_load();
    raychat_logo_manager();



    i.addEventListener('focus', function (e) {
        raychat_responsive_in_iphone_open()

        f.className += " active";


    });

    i.addEventListener('focusout', function (e) {



        f.classList.remove("active");





    });


    i.addEventListener('input', function (e) {

        tdata.msg = e.currentTarget.value;
        tdata.agentId = raychat_local_storage.getItem('raychat_agent_id');
        tdata.conversationId = raychat_local_storage.getItem('raychat_conversationId');



        // check for length
        if (!(e.currentTarget.value.length === 0 || !e.currentTarget.value.trim())) {

            // if hasClass active
            if (!h.className.match(/\bactive\b/)) {
                h.className += " active";
                h.getElementsByClassName('custom-file-upload')[0].classList.remove("active");
                h.getElementsByClassName('custom-file-upload')[0].style.display = "none";
            }
        } else {

            h.classList.remove("active");
            h.getElementsByClassName('custom-file-upload')[0].className += " active";
            h.getElementsByClassName('custom-file-upload')[0].style.display = "inline-block";
        }

    });




    String.prototype.lines = function () { return this.split(/\r*\n/); }
    String.prototype.lineCount = function () { return this.lines().length; }




    i.addEventListener('keydown', function (e) {



        // var lht = parseInt($('#textarea').css('lineHeight'), 10);
        // var lines = $('#textarea').prop('scrollHeight') / lht;
        // console.log(lines);



        var textareaScrollHeight = Math.min(i.scrollHeight);





        if (e.ctrlKey && (e.keyCode == 13 || e.which == 13)) {
            e.currentTarget.value += "\n";

            // var containerHeight = Number(s.style.height.replace(/%/g, ''))
            // containerHeight = containerHeight - 2
            // s.style.height = containerHeight + "%";


            // console.log(document.getElementsByClassName('raychat_main_container_footer')[0].style)
            // var footerHeight = document.getElementById('raychat_main_container_footer').clientHeight;

            // footerHeight = footerHeight + 10;




            // document.getElementById('raychat_main_container_footer').style.height = footerHeight + "px"


            return false;
        }

        // check for Enter
        if (e.which == 13 || e.keyCode == 13) {

            snd(e.currentTarget.value.replace(/\r?\n/g, '<br>'), false);
            h.classList.remove("active");
            h.getElementsByClassName('custom-file-upload')[0].className += " active";
            h.getElementsByClassName('custom-file-upload')[0].style.display = "inline-block";
            e.currentTarget.value = "";
            e.preventDefault();
        }
    });
    d.addEventListener('click', function (e) {
        //
        // q.className = q.className.replace(/\bactive\b/, '');
        // openedEmoji = false;
        //
        // console.log(e.currentTarget);
        // q.className = q.className.replace(/\bactive\b/, '');

    });
    s.addEventListener("dragover", function (e) {
        e.preventDefault()
        e.stopPropagation()
    });

    s.addEventListener("dragleave", function (e) {
        e.preventDefault()
        e.stopPropagation()
    });

    s.addEventListener("drop", function (e) {
        e.preventDefault()
        e.stopPropagation()

        var file = e.dataTransfer.files[0];

        if (raychat_validate_file(file)) {
            raychat_open_verify(file)
        }

    });

    i.addEventListener("dragover", function (e) {
        e.preventDefault()
        e.stopPropagation()
    });

    i.addEventListener("dragleave", function (e) {
        e.preventDefault()
        e.stopPropagation()
    });

    i.addEventListener("drop", function (e) {
        e.preventDefault()
        e.stopPropagation()

        var file = e.dataTransfer.files[0];

        if (raychat_validate_file(file)) {
            raychat_open_verify(file)
        }

    });


    var raychat_main_container_scrollHeight = s.scrollHeight

    s.addEventListener('scroll', function (e) {
        if (allowForScrollToFetchMore && s.scrollTop == 0) {

            fetchMoreChat()
        }
    });


    document.onkeydown = function (evt) {
        evt = evt || window.event;
        var isEscape = false;
        if ("key" in evt) {
            isEscape = (evt.key === "Escape" || evt.key === "Esc");
        } else {
            isEscape = (evt.keyCode === 27);
        }
        if (isEscape) {
            raychat_escape_button_clicked();
        }
    };
    parent.onkeydown = function (evt) {
        evt = evt || window.event;
        var isEscape = false;
        if ("key" in evt) {
            isEscape = (evt.key == "Escape" || evt.key == "Esc");
        } else {
            isEscape = (evt.keyCode == 27);
        }
        if (isEscape) {
            raychat_escape_button_clicked();
        }
    };

    document.onpaste = function (event) {

        var items = (event.clipboardData || event.originalEvent.clipboardData).items;
        for (var index = 0; index < items.length; index++) {

            var item = items[index];
            if (item.kind === 'file') {


                if (raychat_tmp_file_size != item.getAsFile().size) {


                    var file = item.getAsFile();
                    if (raychat_validate_file(file)) {
                        raychat_open_verify(file)
                    }


                    raychat_tmp_file_size = item.getAsFile().size;
                }


            }
        }
    };


    var timeSpent = 0;
    var timer;
    timer = setInterval(function () {
        timeSpent++;
    }, 998);

    tdata.browser = {
        name: browserName,
        ver: fullVersion,
        os: OSName,
        mobile: detectmob()
    };

    if (parent && parent.document && parent.document.referrer) {
        tdata.browser.referrer = parent.document.referrer
    }


    raychat_avoid_sending(true);







    // read user id from url when comming from email
    // then load it as a current user
    if (location.search) {
        var urlQueryString = location.search.substr(1, location.search.length);
        var parsed_qs = parse_query_string(urlQueryString)

        if (parsed_qs.hasOwnProperty('raychat_widget_id') && parsed_qs.hasOwnProperty('source') && parsed_qs.source === "email") {

            if (!entity) {
                var entity = {}
            }
            entity.load = true
            entity.userId = parsed_qs.raychat_widget_id
        }
    }



    if (entity) {

        document.getElementById('raychat_main_container_body_chat').innerHTML = "";

        if (entity.load) {
            tdata.id = entity.userId
        }

    }


    tdata.channelId = widget.channel.id;
    tdata.containerId = widget.container.id;
    if (widget.channel && widget.channel.sendForm) {
        tdata.sendForm = widget.channel.sendForm
    }
    if (widget.channel && widget.channel.officeHours) {
        tdata.officeHours = widget.channel.officeHours
    }
    if (widget.channel && widget.channel.notOfficeHours) {
        tdata.notOfficeHours = widget.channel.notOfficeHours
    }
    tdata.agents = widget.agents
    tdata.channelPhoto = JSON.parse(document.getElementById('raychat_scripts').getAttribute('widget')).channelPhoto;



    io.socket.get(pubsub + "/newvisitor", tdata, function (resData, jwres) {




        if (!resData.success) {
            raychat_toggle_spinner(false);
            document.getElementById('raychat_main_textarea').placeholder = widget.lang.forConnectingAgainPleaseRefreashYourBrowser;
            raychat_local_storage.removeAll();
            document.getElementById('raychat_main_textarea').disabled = true;
            io.socket.disconnect();
        } else {










            if (!resData.openConversation) {
                raychat_conversationClosed(true)
            } else {

                if (raychat_local_storage.getItem('raychat_agent_id')) {
                    var thisAgent = {
                        name: raychat_local_storage.getItem('raychat_agent_name'),
                        id: raychat_local_storage.getItem('raychat_agent_id'),
                        avatar: raychat_local_storage.getItem('raychat_agent_avatar'),
                        title: raychat_local_storage.getItem('raychat_agent_title'),
                        conversationId: raychat_local_storage.getItem('raychat_conversationId')
                    };
                    raychat_agent_accept(thisAgent);
                } else {
                    raychat_local_storage.setItem('raychat_agent_id', resData.openConversationAgentId)
                    raychat_getAgents()
                }
            }

            // isUserLock = (resData.lockForFillDetails && (widget.channel.notOfficeHours.offlineMessage.active || widget.channel.sendForm.active));





            raychat_local_storage.setItem('clientName', resData.name)
            raychat_local_storage.setItem('chatCount', resData.chatCount)
            raychat_local_storage.setItem('agent', resData.agent)









            if (!raychat_local_storage.getItem('rayToken')) {
                var addToRoomData = {
                    user: {
                        id: resData.id,
                        name: raychat_local_storage.getItem('clientName'),
                        agent: raychat_local_storage.getItem('agent'),
                        chatCount: raychat_local_storage.getItem('chatCount'),
                        href: window.location.href,
                        channelId: widget.channel.id,
                        containerId: widget.container.id
                    }
                }


                io.socket.post(pubsub + '/socket/onlyAddToRoom', addToRoomData, function (resData, jwres) { })
            }
            raychat_local_storage.setItem("rayToken", resData.id);
            localStorage.setItem("rayToken", resData.id);
            visitorDetailsComplete = true

            raychat_toggle_spinner(false);


            if (!detectmob()) {
                document.getElementById('raychat_main_textarea').focus();
            }

            totalChatCount = resData.chatCount || 0;




            if (resData.conversation) {
                renderedChatCount = resData.conversation.chats.length



                if (resData.conversation.chats.length > 0) {
                    if (totalChatCount >= renderedChatCount) {
                        allowForScrollToFetchMore = true;
                    }
                    raychat_pending_for_automessage = false;
                    // parent.raychat_data_fetched();
                    resData.conversation.chats = resData.conversation.chats.reverse()
                    for (var i = 0; i < resData.conversation.chats.length; i++) {
                        if (resData.conversation.chats[i].meta.userId === resData.id) {
                            resData.conversation.chats[i].me = true;
                            appendMsg(resData.conversation.chats[i].message, resData.conversation.chats[i]);

                        } else {
                            resData.conversation.chats[i].me = false;


                            appendMsgAgent(resData.conversation.chats[i].message, resData.conversation.chats[i].meta.user_avatar, resData.conversation.chats[i].meta.userId, resData.conversation.chats[i].id, null, resData.conversation.chats[i])
                        }
                    }
                }
            }





            offlineMessageSetting = resData.offlineMessage;




            if (offlineMessageSetting && offlineMessageSetting.active) {

                if (JSON.parse(offlineMessageSetting.form.beforeSendingMessage) || resData.lockForFillDetails) {

                    if (JSON.parse(offlineMessageSetting.form.forceGetUserDetails)) {
                        raychat_avoid_sending(true);
                        document.getElementById('raychat_main_textarea').disabled = true;
                        document.getElementById('raychat_main_textarea').placeholder = widget.lang.pleaseFillForm;
                        document.getElementById('raychat_main_textarea').className += " force_for_fill_form";
                    } else {
                        document.getElementById('raychat_main_textarea').disabled = false;
                        document.getElementById('raychat_main_textarea').placeholder = widget.lang.sendMessage;
                        raychat_avoid_sending(false);
                    }
                    showForm(offlineMessageSetting, { email: resData.email, phone: resData.phone });


                } else {
                    document.getElementById('raychat_main_textarea').disabled = false;
                    document.getElementById('raychat_main_textarea').placeholder = widget.lang.sendMessage;
                    raychat_avoid_sending(false);
                }
            } else {
                document.getElementById('raychat_main_textarea').disabled = false;
                document.getElementById('raychat_main_textarea').placeholder = widget.lang.sendMessage;
                raychat_avoid_sending(false);
            }


            // if (resData.lockForFillDetails && widget.channel.notOfficeHours.offlineMessage.form.forceGetUserDetails && widget.channel.notOfficeHours.offlineMessage.active) {
            //   if (widget.channel.notOfficeHours.offlineMessage.form.forceGetUserDetails) {
            //     raychat_avoid_sending(true);
            //     document.getElementById('raychat_main_textarea').disabled = true;
            //     document.getElementById('raychat_main_textarea').placeholder = widget.lang.pleaseFillForm;
            //     document.getElementById('raychat_main_textarea').className += " force_for_fill_form";
            //   }
            //   showForm(widget.channel.notOfficeHours.offlineMessage, { email: resData.email || '', phone: resData.phone || '' });
            // }
            // else if (resData.lockForFillDetails && widget.channel.sendForm.form.forceGetUserDetails && widget.channel.sendForm.active) {
            //   if (widget.channel.sendForm.form.forceGetUserDetails) {
            //     raychat_avoid_sending(true);
            //     document.getElementById('raychat_main_textarea').disabled = true;
            //     document.getElementById('raychat_main_textarea').placeholder = widget.lang.pleaseFillForm;
            //     document.getElementById('raychat_main_textarea').className += " force_for_fill_form";
            //   }
            //   showForm(widget.channel.sendForm, { email: resData.email || '', phone: resData.phone || '' });
            // }
            // else {
            // document.getElementById('raychat_main_textarea').disabled = false;
            // document.getElementById('raychat_main_textarea').placeholder = widget.lang.sendMessage;
            // raychat_avoid_sending(false);
            // }



            parent.Raychat.__profile_updated(resData);
            if (entity) {
                parent.Raychat.load(entity);

            } else {
                parent.Raychat.load();

            }

        }


    });




    io.socket.on('raychat_newMessage', function (res) {

        appendMsgAgent(res.message, res.agent_avatar, res.agent_id, res.chatId, true, res.messageObj, false);
        raychat_new_message_notification();
        var userAvatar;
        if (raychat_local_storage.getItem('raychat_agent_avatar')) {
            userAvatar = webAppUrl + "/" + raychat_local_storage.getItem('raychat_agent_avatar');
        } else {
            userAvatar = webAppUrl + "/" + raychat_local_storage.getItem('raychat_channel_photo');
        }


        if (res.messageObj && res.messageObj.type == 0) {
            parent.raychat_set_automessage_preview(widget.lang.photoMessage, raychat_local_storage.getItem('raychat_agent_name'), userAvatar);
        } else if (res.messageObj && res.messageObj.type == 1) {

            parent.raychat_set_automessage_preview(widget.lang.videoMessage, raychat_local_storage.getItem('raychat_agent_name'), userAvatar);

        } else if (res.messageObj && res.messageObj.type == 2) {

            parent.raychat_set_automessage_preview(widget.lang.musicMessage, raychat_local_storage.getItem('raychat_agent_name'), userAvatar);

        } else if (res.messageObj && res.messageObj.type == 3 || res.messageObj.type == 4) {

            parent.raychat_set_automessage_preview(widget.lang.fileMessage, raychat_local_storage.getItem('raychat_agent_name'), userAvatar);

        } else if (res.message.substr(0, 21) == "00raychat:data:image0") {
            parent.raychat_set_automessage_preview(widget.lang.photoMessage, raychat_local_storage.getItem('raychat_agent_name'), userAvatar);
        } else {
            parent.raychat_set_automessage_preview(res.message, raychat_local_storage.getItem('raychat_agent_name'), userAvatar);

        }
    });
    io.socket.on('conversationClosed', function (res) {
        raychat_conversationClosed();
    });


    io.socket.on('showFormAndMessage', function (res) {
        offlineMessageSetting = res.offlineMessage;

        if (JSON.parse(res.offlineMessage.form.forceGetUserDetails)) {
            raychat_avoid_sending(true);
            document.getElementById('raychat_main_textarea').disabled = true;
            document.getElementById('raychat_main_textarea').placeholder = widget.lang.pleaseFillForm;
            document.getElementById('raychat_main_textarea').className += " force_for_fill_form";
        }
        showForm(res.offlineMessage, { email: res.email, phone: res.phone });

    });

    function fetchMoreChat() {

        tdata.page = renderedPage;
        io.socket.get(pubsub + "/chats/getMore", tdata, function (resData, jwres) {


            var firstMessage = document.getElementsByClassName('raychat_main_container_body_chat_item')[0]




            renderedChatCount += resData.chats.length

            if (resData.chats.length > 0) {
                for (var i = 0; i < resData.chats.length; i++) {
                    if (resData.chats[i].meta.userId === tdata.id) {
                        resData.chats[i].me = true;
                        appendMsg(resData.chats[i].message, resData.chats[i], firstMessage);

                    } else {
                        resData.chats[i].me = false;


                        appendMsgAgent(resData.chats[i].message, resData.chats[i].meta.user_avatar, resData.chats[i].meta.userId, resData.chats[i].id, null, resData.chats[i], firstMessage)
                    }
                }
                renderedPage++
            } else {
                allowForScrollToFetchMore = false
            }



        })
    }

    function showForm(res, user) {







        var content = '';
        var offlineMessage = '';
        currentForm = res;
        if (JSON.parse(res.offlineMessage.active)) {

            offlineMessage = res.offlineMessage.message
        }

        if (res.form.fieldName === "name") {
            //es6
            //     content = `
            //     <div class="raychat_main_container_body_chat_item raychat_main_container_body_chat_agent fadeInUp raychat_animated raychat_main_container_body_chat_item_inputs">
            //      <div class="raychat_main_container_body_chat_item_avatar" id="raychat_main_container_body_chat_item_avatar_email_tel"></div>
            //      <div class="raychat_main_container_body_chat_item_message_agent raychat_main_container_body_chat_item_message_agent_email_phone_form">
            //         <h4 class="raychat_main_container_body_chat_item_message_agent_email_phone_form_heading">${widget.lang.be_notified}</h4> 
            //         <p style="margin: 5px auto 14px;">${offlineMessage}</p>
            //     <div class="raychat_main_container_body_chat_item_message_agent_email_phone_form_body">

            //         <div>                    
            //         <div><input type="text"  id="raychat_main_container_body_chat_item_message_agent_email_phone_form_body_name_val" placeholder="${widget.lang.enter_your_name}"><div>
            //             <div class="raychat_user_more_details_response success raychat_noselect" id="raychat_user_more_details_response"></div>
            //             <div><button class="raychat_animated fadeIn" onclick="raychat_send_user_data(this)">${widget.lang.submit}</button></div>
            //         </div>

            //     </div>
            // </div></div>`;
            content = "\n            <div class=\"raychat_main_container_body_chat_item raychat_main_container_body_chat_agent fadeInUp raychat_animated raychat_main_container_body_chat_item_inputs\">\n             <div class=\"raychat_main_container_body_chat_item_avatar\" id=\"raychat_main_container_body_chat_item_avatar_email_tel\"></div>\n             <div class=\"raychat_main_container_body_chat_item_message_agent raychat_main_container_body_chat_item_message_agent_email_phone_form\">\n                <h4 class=\"raychat_main_container_body_chat_item_message_agent_email_phone_form_heading\">" + widget.lang.be_notified + "</h4> \n                <p style=\"margin: 5px auto 14px;\">" + offlineMessage + "</p>\n            <div class=\"raychat_main_container_body_chat_item_message_agent_email_phone_form_body\">\n\n                <div>                    \n                <div><input type=\"text\"  id=\"raychat_main_container_body_chat_item_message_agent_email_phone_form_body_name_val\" placeholder=\"" + widget.lang.enter_your_name + "\"><div>\n                    <div class=\"raychat_user_more_details_response success raychat_noselect\" id=\"raychat_user_more_details_response\"></div>\n                    <div><button class=\"raychat_animated fadeIn\" onclick=\"raychat_send_user_data(this)\">" + widget.lang.submit + "</button></div>\n                </div>\n\n            </div>\n        </div></div>";
        } else if (res.form.fieldName === "email") {
            // es6
            //     content = `
            //     <div class="raychat_main_container_body_chat_item raychat_main_container_body_chat_agent fadeInUp raychat_animated raychat_main_container_body_chat_item_inputs">
            //      <div class="raychat_main_container_body_chat_item_avatar" id="raychat_main_container_body_chat_item_avatar_email_tel"></div>
            //      <div class="raychat_main_container_body_chat_item_message_agent raychat_main_container_body_chat_item_message_agent_email_phone_form">
            //         <h4 class="raychat_main_container_body_chat_item_message_agent_email_phone_form_heading">${widget.lang.be_notified}</h4> 
            //         <p style="margin: 5px auto 14px;">${offlineMessage}</p>
            //     <div class="raychat_main_container_body_chat_item_message_agent_email_phone_form_body">

            //         <div>                    
            //             <div><input type="email" id="raychat_main_container_body_chat_item_message_agent_email_phone_form_body_email_val" placeholder="${widget.lang.enter_your_email}"><div>
            //             <div class="raychat_user_more_details_response success raychat_noselect" id="raychat_user_more_details_response"></div>
            //             <div><button class="raychat_animated fadeIn" onclick="raychat_send_user_data(this)">${widget.lang.submit}</button></div>
            //         </div>

            //     </div>
            // </div></div>`;
            "use strict";

            content = "\n            <div class=\"raychat_main_container_body_chat_item raychat_main_container_body_chat_agent fadeInUp raychat_animated raychat_main_container_body_chat_item_inputs\">\n             <div class=\"raychat_main_container_body_chat_item_avatar\" id=\"raychat_main_container_body_chat_item_avatar_email_tel\"></div>\n             <div class=\"raychat_main_container_body_chat_item_message_agent raychat_main_container_body_chat_item_message_agent_email_phone_form\">\n                <h4 class=\"raychat_main_container_body_chat_item_message_agent_email_phone_form_heading\">" + widget.lang.be_notified + "</h4> \n                <p style=\"margin: 5px auto 14px;\">" + offlineMessage + "</p>\n            <div class=\"raychat_main_container_body_chat_item_message_agent_email_phone_form_body\">\n\n                <div>                    \n                    <div><input type=\"email\" id=\"raychat_main_container_body_chat_item_message_agent_email_phone_form_body_email_val\" placeholder=\"" + widget.lang.enter_your_email + "\"><div>\n                    <div class=\"raychat_user_more_details_response success raychat_noselect\" id=\"raychat_user_more_details_response\"></div>\n                    <div><button class=\"raychat_animated fadeIn\" onclick=\"raychat_send_user_data(this)\">" + widget.lang.submit + "</button></div>\n                </div>\n\n            </div>\n        </div></div>";
        } else if (res.form.fieldName === "phone") {

            //     content = `
            //     <div class="raychat_main_container_body_chat_item raychat_main_container_body_chat_agent fadeInUp raychat_animated raychat_main_container_body_chat_item_inputs">
            //      <div class="raychat_main_container_body_chat_item_avatar" id="raychat_main_container_body_chat_item_avatar_email_tel"></div>
            //      <div class="raychat_main_container_body_chat_item_message_agent raychat_main_container_body_chat_item_message_agent_email_phone_form">
            //         <h4 class="raychat_main_container_body_chat_item_message_agent_email_phone_form_heading">${widget.lang.be_notified}</h4> 
            //         <p style="margin: 5px auto 14px;">${offlineMessage}</p>
            //     <div class="raychat_main_container_body_chat_item_message_agent_email_phone_form_body">

            //         <div>                    
            //             <div><input type="text"  id="raychat_main_container_body_chat_item_message_agent_email_phone_form_body_phone_val" placeholder="${widget.lang.enter_your_phone_number}"><div>
            //             <div class="raychat_user_more_details_response success raychat_noselect" id="raychat_user_more_details_response"></div>
            //             <div><button class="raychat_animated fadeIn" onclick="raychat_send_user_data(this)">${widget.lang.submit}</button></div>
            //         </div>

            //     </div>
            // </div></div>`;
            "use strict";

            content = "\n            <div class=\"raychat_main_container_body_chat_item raychat_main_container_body_chat_agent fadeInUp raychat_animated raychat_main_container_body_chat_item_inputs\">\n             <div class=\"raychat_main_container_body_chat_item_avatar\" id=\"raychat_main_container_body_chat_item_avatar_email_tel\"></div>\n             <div class=\"raychat_main_container_body_chat_item_message_agent raychat_main_container_body_chat_item_message_agent_email_phone_form\">\n                <h4 class=\"raychat_main_container_body_chat_item_message_agent_email_phone_form_heading\">" + widget.lang.be_notified + "</h4> \n                <p style=\"margin: 5px auto 14px;\">" + offlineMessage + "</p>\n            <div class=\"raychat_main_container_body_chat_item_message_agent_email_phone_form_body\">\n\n                <div>                    \n                    <div><input type=\"text\"  id=\"raychat_main_container_body_chat_item_message_agent_email_phone_form_body_phone_val\" placeholder=\"" + widget.lang.enter_your_phone_number + "\"><div>\n                    <div class=\"raychat_user_more_details_response success raychat_noselect\" id=\"raychat_user_more_details_response\"></div>\n                    <div><button class=\"raychat_animated fadeIn\" onclick=\"raychat_send_user_data(this)\">" + widget.lang.submit + "</button></div>\n                </div>\n\n            </div>\n        </div></div>";

        } else if (res.form.fieldName === "both") {

            // es6
            //     content = `
            //     <div class="raychat_main_container_body_chat_item raychat_main_container_body_chat_agent fadeInUp raychat_animated raychat_main_container_body_chat_item_inputs">
            //      <div class="raychat_main_container_body_chat_item_avatar" id="raychat_main_container_body_chat_item_avatar_email_tel"></div>
            //      <div class="raychat_main_container_body_chat_item_message_agent raychat_main_container_body_chat_item_message_agent_email_phone_form">
            //         <h4 class="raychat_main_container_body_chat_item_message_agent_email_phone_form_heading">${widget.lang.be_notified}</h4> 
            //         <p style="margin: 5px auto 14px;">${offlineMessage}</p>
            //     <div class="raychat_main_container_body_chat_item_message_agent_email_phone_form_body">

            //         <div>

            //             <div><input type="email" id="raychat_main_container_body_chat_item_message_agent_email_phone_form_body_email_val" placeholder="${widget.lang.enter_your_email}"><div>
            //             <div><input type="text"  id="raychat_main_container_body_chat_item_message_agent_email_phone_form_body_phone_val" placeholder="${widget.lang.enter_your_phone_number}"><div>
            //             <div class="raychat_user_more_details_response success raychat_noselect" id="raychat_user_more_details_response"></div>
            //             <div><button class="raychat_animated fadeIn" onclick="raychat_send_user_data(this)">${widget.lang.submit}</button></div>
            //         </div>

            //     </div>
            // </div></div>`;
            "use strict";

            content = "\n            <div class=\"raychat_main_container_body_chat_item raychat_main_container_body_chat_agent fadeInUp raychat_animated raychat_main_container_body_chat_item_inputs\">\n             <div class=\"raychat_main_container_body_chat_item_avatar\" id=\"raychat_main_container_body_chat_item_avatar_email_tel\"></div>\n             <div class=\"raychat_main_container_body_chat_item_message_agent raychat_main_container_body_chat_item_message_agent_email_phone_form\">\n                <h4 class=\"raychat_main_container_body_chat_item_message_agent_email_phone_form_heading\">" + widget.lang.be_notified + "</h4> \n                <p style=\"margin: 5px auto 14px;\">" + offlineMessage + "</p>\n            <div class=\"raychat_main_container_body_chat_item_message_agent_email_phone_form_body\">\n\n                <div>\n                    \n                    <div><input type=\"email\" id=\"raychat_main_container_body_chat_item_message_agent_email_phone_form_body_email_val\" placeholder=\"" + widget.lang.enter_your_email + "\"><div>\n                    <div><input type=\"text\"  id=\"raychat_main_container_body_chat_item_message_agent_email_phone_form_body_phone_val\" placeholder=\"" + widget.lang.enter_your_phone_number + "\"><div>\n                    <div class=\"raychat_user_more_details_response success raychat_noselect\" id=\"raychat_user_more_details_response\"></div>\n                    <div><button class=\"raychat_animated fadeIn\" onclick=\"raychat_send_user_data(this)\">" + widget.lang.submit + "</button></div>\n                </div>\n\n            </div>\n        </div></div>";




        } else if (res.form.fieldName === "allThree") {
            //es6
            //     content = `
            //     <div class="raychat_main_container_body_chat_item raychat_main_container_body_chat_agent fadeInUp raychat_animated raychat_main_container_body_chat_item_inputs">
            //      <div class="raychat_main_container_body_chat_item_avatar" id="raychat_main_container_body_chat_item_avatar_email_tel"></div>
            //      <div class="raychat_main_container_body_chat_item_message_agent raychat_main_container_body_chat_item_message_agent_email_phone_form">
            //         <h4 class="raychat_main_container_body_chat_item_message_agent_email_phone_form_heading">${widget.lang.be_notified}</h4> 
            //         <p style="margin: 5px auto 14px;">${offlineMessage}</p>
            //     <div class="raychat_main_container_body_chat_item_message_agent_email_phone_form_body">

            //         <div>
            //             <div><input type="text"  id="raychat_main_container_body_chat_item_message_agent_email_phone_form_body_name_val" placeholder="${widget.lang.enter_your_name}"><div>
            //             <div><input type="email" id="raychat_main_container_body_chat_item_message_agent_email_phone_form_body_email_val" placeholder="${widget.lang.enter_your_email}"><div>
            //             <div><input type="text"  id="raychat_main_container_body_chat_item_message_agent_email_phone_form_body_phone_val" placeholder="${widget.lang.enter_your_phone_number}"><div>
            //             <div class="raychat_user_more_details_response success raychat_noselect" id="raychat_user_more_details_response"></div>
            //             <div><button class="raychat_animated fadeIn" onclick="raychat_send_user_data(this)">${widget.lang.submit}</button></div>
            //         </div>

            //     </div>
            // </div></div>`;

            content = "\n            <div class=\"raychat_main_container_body_chat_item raychat_main_container_body_chat_agent fadeInUp raychat_animated raychat_main_container_body_chat_item_inputs\">\n             <div class=\"raychat_main_container_body_chat_item_avatar\" id=\"raychat_main_container_body_chat_item_avatar_email_tel\"></div>\n             <div class=\"raychat_main_container_body_chat_item_message_agent raychat_main_container_body_chat_item_message_agent_email_phone_form\">\n                <h4 class=\"raychat_main_container_body_chat_item_message_agent_email_phone_form_heading\">" + widget.lang.be_notified + "</h4> \n                <p style=\"margin: 5px auto 14px;\">" + offlineMessage + "</p>\n            <div class=\"raychat_main_container_body_chat_item_message_agent_email_phone_form_body\">\n\n                <div>\n                    <div><input type=\"text\"  id=\"raychat_main_container_body_chat_item_message_agent_email_phone_form_body_name_val\" placeholder=\"" + widget.lang.enter_your_name + "\"><div>\n                    <div><input type=\"email\" id=\"raychat_main_container_body_chat_item_message_agent_email_phone_form_body_email_val\" placeholder=\"" + widget.lang.enter_your_email + "\"><div>\n                    <div><input type=\"text\"  id=\"raychat_main_container_body_chat_item_message_agent_email_phone_form_body_phone_val\" placeholder=\"" + widget.lang.enter_your_phone_number + "\"><div>\n                    <div class=\"raychat_user_more_details_response success raychat_noselect\" id=\"raychat_user_more_details_response\"></div>\n                    <div><button class=\"raychat_animated fadeIn\" onclick=\"raychat_send_user_data(this)\">" + widget.lang.submit + "</button></div>\n                </div>\n\n            </div>\n        </div></div>";
        }

        document.getElementById('raychat_main_container_body_chat').insertAdjacentHTML('beforeend', content);

        var onlineAgentsCount = 0;
        var agentAvatar;
        if (raychat_local_storage.getItem('raychat_agent_avatar')) {
            agentAvatar = "url('" + webAppUrl + raychat_local_storage.getItem('raychat_agent_avatar') + "');";
            onlineAgentsCount++;
        } else {
            if (document.getElementById('raychat_scripts').getAttribute('raychat_onlineAgents') !== "undefined" && document.getElementById('raychat_scripts').getAttribute('raychat_onlineAgents') !== "") {
                agentAvatar = "url('" + webAppUrl + document.getElementById('raychat_scripts').getAttribute('raychat_onlineAgents') + "')";
                onlineAgentsCount++;
            }
        }
        if (onlineAgentsCount === 0) {
            agentAvatar = "url('" + webAppUrl + "/" + raychat_local_storage.getItem('raychat_channel_photo') + "')";
        }


        if (document.getElementById('raychat_main_container_body_chat_item_avatar_email_tel')) {
            document.getElementById('raychat_main_container_body_chat_item_avatar_email_tel').style.backgroundImage = agentAvatar;
        }


        if (user) {


            /*
             * fill email field if user fill it once  */
            if (user.email) {
                if (user.email.search("@raychat.ir") === -1) {
                    if (document.getElementById('raychat_main_container_body_chat_item_message_agent_email_phone_form_body_email_val')) {
                        document.getElementById('raychat_main_container_body_chat_item_message_agent_email_phone_form_body_email_val').value = user.email;
                    }
                }
            }


            if (user.phone) {
                if (document.getElementById('raychat_main_container_body_chat_item_message_agent_email_phone_form_body_phone_val')) {
                    document.getElementById('raychat_main_container_body_chat_item_message_agent_email_phone_form_body_phone_val').value = user.phone;
                }
            }
        }


        if (document.getElementsByClassName('raychat_main_container_body_chat_item_inputs')[0]) {
            document.getElementsByClassName('raychat_main_container_body_chat_item_inputs')[0].style.display = "block";
        }


        if (document.getElementById('raychat_main_container_body_chat_item_message_agent_email_phone_form_tab_phone')) {
            document.getElementById('raychat_main_container_body_chat_item_message_agent_email_phone_form_tab_phone').addEventListener('click', function (e) {
                if (!e.currentTarget.className.match(/\bactive\b/)) {
                    e.currentTarget.className += " active";
                }
                document.getElementById('raychat_main_container_body_chat_item_message_agent_email_phone_form_tab_email').classList.remove("active");


                if (!document.getElementById('raychat_main_container_body_chat_item_message_agent_email_phone_form_body_tel').className.match(/\bactive\b/)) {
                    document.getElementById('raychat_main_container_body_chat_item_message_agent_email_phone_form_body_tel').className += " active";
                }
                document.getElementById('raychat_main_container_body_chat_item_message_agent_email_phone_form_body_email').classList.remove("active");
            });
        }


        if (document.getElementById('raychat_main_container_body_chat_item_message_agent_email_phone_form_tab_email')) {
            document.getElementById('raychat_main_container_body_chat_item_message_agent_email_phone_form_tab_email').addEventListener('click', function (e) {

                if (!e.currentTarget.className.match(/\bactive\b/)) {
                    e.currentTarget.className += " active";
                }
                document.getElementById('raychat_main_container_body_chat_item_message_agent_email_phone_form_tab_phone').classList.remove("active");

                if (!document.getElementById('raychat_main_container_body_chat_item_message_agent_email_phone_form_body_email').className.match(/\bactive\b/)) {
                    document.getElementById('raychat_main_container_body_chat_item_message_agent_email_phone_form_body_email').className += " active";
                }
                document.getElementById('raychat_main_container_body_chat_item_message_agent_email_phone_form_body_tel').classList.remove("active");
            });
        }


        if (document.getElementById('raychat_main_container_body_chat_item_message_agent_email_phone_form_body_email_val')) {
            document.getElementById('raychat_main_container_body_chat_item_message_agent_email_phone_form_body_email_val').addEventListener('keydown', function (e) {
                if (e.which === 13 || e.keyCode === 13) {


                    raychat_send_email_add(e.currentTarget);

                }
            });
        }

        if (document.getElementById('raychat_main_container_body_chat_item_message_agent_email_phone_form_body_phone_val')) {
            document.getElementById('raychat_main_container_body_chat_item_message_agent_email_phone_form_body_phone_val').addEventListener('keydown', function (e) {
                if (e.which === 13 || e.keyCode === 13) {
                    raychat_send_email_add(e.currentTarget);
                }
            });
        }


        if (JSON.parse(res.form.forceGetUserDetails)) {
            closest(document.getElementById('raychat_main_textarea'), '.raychat_main_container_footer').addEventListener('click', scroll_to_form, true);
        }





        scrollTo(s, s.scrollHeight, 200);
    }

    function closest(el, selector) {
        var matchesFn;

        // find vendor prefix
        ['matches', 'webkitMatchesSelector', 'mozMatchesSelector', 'msMatchesSelector', 'oMatchesSelector'].some(function (fn) {
            if (typeof document.body[fn] === 'function') {
                matchesFn = fn;
                return true;
            }
            return false;
        })

        var parent;

        // traverse parents
        while (el) {
            parent = el.parentElement;
            if (parent && parent[matchesFn](selector)) {
                return parent;
            }
            el = parent;
        }

        return null;
    }




    io.socket.on('refreshBrowser', function (res) {
        if (confirm(widget.lang.allowReloadPage)) {
            parent.location.reload();
        }
    });
    io.socket.on('sendXYtoMe', function (res) {

        (function () {
            parent.document.onmousemove = handleMouseMove;

            function handleMouseMove(event) {
                var dot, eventDoc, doc, body, pageX, pageY;

                event = parent.event || event // IE-ism

                // If pageX/Y aren't available and clientX/Y are,
                // calculate pageX/Y - logic taken from jQuery.
                // (This is to support old IE)
                if (event.pageX == null && event.clientX != null) {
                    eventDoc = (event.target && event.target.ownerDocument) || document;
                    doc = eventDoc.documentElement;
                    body = eventDoc.body;

                    event.pageX = event.clientX +
                        (doc && doc.scrollLeft || body && body.scrollLeft || 0) -
                        (doc && doc.clientLeft || body && body.clientLeft || 0);
                    event.pageY = event.clientY +
                        (doc && doc.scrollTop || body && body.scrollTop || 0) -
                        (doc && doc.clientTop || body && body.clientTop || 0);
                }

                // Use event.pageX / event.pageY here
                console.log(event.pageX)
                console.log(event.pageY)

                io.socket.post(pubsub + "/realTimeBrowser", {
                    agentId: res.agentId,
                    x: event.pageX,
                    y: event.pageY
                }, function (resData, jwres) {

                })
            }
        })();
    });


    io.socket.on('acceptedChat', function (res) {
        raychat_agent_accept(res);
    });

    io.socket.on('raychat_start_chat_with_agent', function (res) {
        raychat_agent_accept(res);
    });
    io.socket.on('chatTransfered', function (res) {

        raychat_agent_transfer(res);
    });
    io.socket.on('rayachat_userIsBanned', function (res) {

        document.getElementById('raychatMainContainer').remove();
        window.parent.document.getElementById('raychatBtn').remove();
        window.parent.document.getElementById('raychat_automessage_preview_container').remove();


    });

    var removeTypingTimeout;
    io.socket.on('typing', function (res) {

        if (res.typing) {
            document.getElementById('raychat_agent_heading_typing').className += " active";
            clearTimeout(removeTypingTimeout);
            removeTypingTimeout = setTimeout(function () {
                document.getElementById('raychat_agent_heading_typing').classList.remove('active');
            }, 50000)
        } else {
            clearTimeout(removeTypingTimeout);
            document.getElementById('raychat_agent_heading_typing').classList.remove('active');
        }
    });

    h.addEventListener('click', function (e) {
        if (!e.currentTarget.getElementsByClassName('custom-file-upload')[0].classList.contains("active")) {
            snd(i.value, false);
            h.classList.remove("active");
            h.getElementsByClassName('custom-file-upload')[0].className += " active";
            h.getElementsByClassName('custom-file-upload')[0].style.display = "inline-block";
            i.value = "";
            if (!iphoneMode) {

                i.focus();
            } else {
                raychat_responsive_in_iphone_close()

            }
        }
    });

    /**
     * if some browser does not support sendAsBinary function
     */
    if (!XMLHttpRequest.prototype.sendAsBinary) {
        XMLHttpRequest.prototype.sendAsBinary = function (datastr) {
            function byteValue(x) {
                return x.charCodeAt(0) & 0xff;
            }

            var ords = Array.prototype.map.call(datastr, byteValue);
            var ui8a = new Uint8Array(ords);
            this.send(ui8a.buffer);
        }
    }

    function raychat_validate_file(file) {
        var validFileTypes = [
            'text/csv', //.csv
            'application/msword', //.doc
            'application/vnd.openxmlformats-officedocument.wordprocessingml.document', //.docx
            'image/gif', //.gif
            'image/jpeg', //.jpeg .jpg
            'application/pdf', //.pdf
            'application/vnd.ms-powerpoint', //.ppt
            'image/svg+xml', //.svg
            'application/x-tar', //.tar
            'image/webp', //.webp
            'application/zip', //.zip
            'application/x-zip-compressed', //.zip
            'application/vnd.ms-excel', //.csv
            'video/mpeg', // .mpeg
            'application/x-rar-compressed', //.rar
            'application/rtf', //.rtf
            'audio/ogg', //.ogg
            'audio/mp3', //.mp3
            'video/ogg', //.ogv
            'image/png', //.png
            'application/vnd.ms-powerpoint',
            'application/x-7z-compressed',
            'video/3gpp',
            'video/mp4',
            'video/mpeg',
            'video/quicktime',
            'video/webm',
            'video/x-ms-wmv',
            'video/x-msvideo',
            'audio/mpeg',
            'audio/x-m4a',
        ];
        if (file) {
            var content;
            if (file.size > widget.container.uploadLimit) {
                content = '<div class="raychat_main_container_body_chat_item_toast_message warning raychat_zoomIn raychat_animated active raychat_noselect" id="raychat_main_container_body_chat_item_toast_message">' + widget.lang.largeFile + '</div>';
                document.getElementById('raychat_main_container_body_chat').insertAdjacentHTML('beforeend', content);
                scrollTo(s, s.scrollHeight, 200);
                return false;
            }
            if (validFileTypes.indexOf(file.type) == -1) {
                content = '<div class="raychat_main_container_body_chat_item_toast_message warning raychat_zoomIn raychat_animated active raychat_noselect" id="raychat_main_container_body_chat_item_toast_message">' + widget.lang.invalidFormat + '</div>';
                document.getElementById('raychat_main_container_body_chat').insertAdjacentHTML('beforeend', content);
                scrollTo(s, s.scrollHeight, 200);
                return false;
            }
            return true;
        }
        return false;
    }


    w.addEventListener('change', function (e) {

        var file = e.currentTarget.files[0];

        if (raychat_validate_file(file)) {

            raychat_open_verify(file)






        }

    });

    // raychat_getAgents();

    raychat_check_responsive();
    parent.window.onresize = function () {
        raychat_check_responsive();
    };




}

function raychat_new_message_notification() {


    if (raychat_new_message_sound) {

        var promise = raychat_new_message_sound.play();

        if (promise !== undefined) {
            promise.catch(function (err) {
                console.warn('playing notification sound rejected by user browser. see more: https://goo.gl/xX8pDD')
            });
        }
    }

    // window.parent.f = widget.lang.newMessage;


    // setTimeout(function () {
    // window.parent.document.title = oldTitle;
    // }, 2000);
    parent.raychat_setCounterOn(++counter);

}

function raychat_logo_manager() {
    var setting = JSON.parse(document.getElementById('raychat_scripts').getAttribute('widget'));

    if (setting.hideRaychatLogo) {
        ww.classList.remove("active");
    }
}

function raychat_escape_button_clicked() {
    if (window.parent.document.getElementById('raychat_open_modal') && window.parent.document.getElementById('raychat_open_modal').classList.contains("active")) {
        window.parent.document.getElementById('raychat_open_modal').click();
    } else if (openedEmoji) {
        document.getElementsByClassName("raychat_main_container_footer_details_div_emoji")[0].click();
    } else if (opened) {
        opened = false;
        parent.raychat_close_container();
    } else if (window.parent.document.getElementById('raychat_automessage_preview_container') && window.parent.document.getElementById('raychat_automessage_preview_container').classList.contains("active")) {
        parent.raychat_close_automessage_preview();
    }
}

function raychatBtnClicked() {



    if (!opened) {
        d.classList.remove("active");
        d.className += " active";
        b.className += " active";
        if (!detectmob()) {
            document.getElementById('raychat_main_textarea').focus();
        }
        scrollTo(s, s.scrollHeight, 200);
        opened = true;

    } else {

        d.className += " fadeOut raychat_animated";
        d.classList.remove("active");
        d.classList.remove("raychat_animated");
        b.classList.remove("active");

        opened = false;
    }
    raychat_check_responsive();
}

function raychat_check_responsive(footerHeightA) {



    var dHeight = d.clientHeight

    var headerHeight = document.getElementsByClassName('raychat_main_container_header')[0].clientHeight
    var footerHeight = f.clientHeight
    if (footerHeightA) footerHeight = footerHeightA




    if (dHeight != 0) {

        s.style.height = dHeight - (headerHeight + footerHeight) + 'px'

    }



    if (detectmob()) {
        if (navigator.platform == 'iPhone' || navigator.platform == 'iPad') {
            parent.window.document.getElementById('raychatFrame').style.maxHeight = parent.window.innerHeight + "px"
        } else {
            parent.window.document.getElementById('raychatFrame').style.maxHeight = "100%"
        }
    }






    // if (parent.window.innerHeight < 640) {
    //   if (!d.classList.contains('responsive')) {

    //     d.className += ' responsive';
    //     uu.className += ' active';
    //     uu2.className += ' active';

    //   }
    //   if (opened) {
    //     if (detectmob()) {
    //       parent.window.document.body.className += " raychat_no_overflow";
    //     }
    //     window.parent.document.getElementById('raychatBtn').style.display = " none";
    //   }
    //   else {
    //     if (detectmob()) {
    //       parent.window.document.body.classList.remove('raychat_no_overflow');
    //     }
    //   }

    //   s.style.height = parent.window.innerHeight - 139 + "px";


    // }
    // else {

    //   s.style.height = "478px";
    //   uu.classList.remove('active');
    //   uu2.classList.remove('active');
    //   d.classList.remove('responsive');

    //   parent.window.document.body.classList.remove('raychat_no_overflow');

    // }

    // if (!opened) {
    //   // window.parent.document.getElementById('raychatBtn').style.display = " block";
    // }


}

function raychat_avoid_sending(bool) {
    var emojiIconBtn = document.getElementsByClassName('raychat_main_container_footer_details_div_emoji')[0];
    var attachFileIcon = document.getElementsByClassName('custom-file-upload')[0];
    if (bool) {
        emojiIconBtn.style.display = "none";
        attachFileIcon.style.display = "none";
    } else {
        if (!iphoneMode) {

            emojiIconBtn.style.display = "inline-block";
        }
        attachFileIcon.style.display = "inline-block";
    }
}

function raycaht_shuffle_array(array) {
    var currentIndex = array.length,
        temporaryValue, randomIndex;

    // While there remain elements to shuffle...
    while (0 !== currentIndex) {

        // Pick a remaining element...
        randomIndex = Math.floor(Math.random() * currentIndex);
        currentIndex -= 1;

        // And swap it with the current element.
        temporaryValue = array[currentIndex];
        array[currentIndex] = array[randomIndex];
        array[randomIndex] = temporaryValue;
    }

    return array;
}

Array.prototype.move = function (oldIndex, newIndex) {
    if (Object.prototype.toString.call(this) === '[object Array]') {
        if (oldIndex && typeof oldIndex == 'number' && newIndex && typeof newIndex == 'number') {
            if (newIndex > this.length) newIndex = this.length;
            this.splice(newIndex, 0, this.splice(oldIndex, 1)[0]);
        }
    }
};

function raychat_getAgents() {



    io.socket.get(pubsub + "/floatChat/getAgents", tdata, function (resData, jwres) {
        var agent;
        var count = 1;
        var arrayOnlineCount = 2;

        if (resData.length <= 0) {
            return false;
        }


        resData = raycaht_shuffle_array(resData);
        var tmpArray = [];
        tmpArray = resData;

        for (var x = 0; x < resData.length; x++) {
            if (resData[x].online) {

                if (x != arrayOnlineCount) {
                    tmpArray.move(x, arrayOnlineCount);
                }
            }
        }
        resData = tmpArray;
        tmpArray = [];


        for (var i = 0; i < resData.length; i++) {

            if (raychat_local_storage.getItem('raychat_agent_id')) {
                if (raychat_local_storage.getItem('raychat_agent_id') === resData[i].id) {


                    var thisAgent = {
                        name: resData[i].name,
                        id: resData[i].id,
                        avatar: resData[i].avatar,
                        title: resData[i].title,
                        conversationId: raychat_local_storage.getItem('raychat_conversationId')
                    };
                    raychat_agent_accept(thisAgent);
                    return false;
                }
            }


            if (count > 3) {
                break;
            }

            if (resData[i].online) {
                agent = '<div class="raychat_main_container_header_agents_' + count + ' raychat_main_container_header_agents_agent fadeInRight raychat_main_container_header_agents_agent_border raychat_animated" style="background-image: url(' + webAppUrl + resData[i].avatar + ');"><span class="raychat_zoomIn raychat_animated raychat_main_container_header_agents_agent_status online"></span></div>'
            } else {
                agent = '<div class="raychat_main_container_header_agents_' + count + ' raychat_main_container_header_agents_agent fadeInRight raychat_main_container_header_agents_agent_border raychat_animated" style="background-image: url(' + webAppUrl + resData[i].avatar + ');"><span class="raychat_main_container_header_agents_agent_status offline"></span></div>'
            }


            count++;
            document.getElementById('raychat_main_container_header_agents_list').insertAdjacentHTML('beforeend', agent);


        }


        var headingH3 = document.getElementsByClassName('raychat_main_container_header_agents_heading')[0].getElementsByTagName('h3')[0];
        var headingP = document.getElementsByClassName('raychat_main_container_header_agents_heading')[0].getElementsByTagName('p')[0];
        if (count === 2) {

            headingH3.style[widget.lang.align] = 93 + "px";
            headingP.style[widget.lang.align] = 93 + "px";
        } else if (count === 3) {
            headingH3.style[widget.lang.align] = 116 + "px";
            headingP.style[widget.lang.align] = 116 + "px";
        }

    });
}

function raychat_strip_tags(_html, br, a) {
    var _tags = [],
        _tag = "";
    for (var _a = 1; _a < arguments.length; _a++) {
        _tag = arguments[_a].replace(/<|>/g, '').trim();
        if (arguments[_a].length > 0) _tags.push(_tag, "/" + _tag);
    }

    if (!(typeof _html == "string") && !(_html instanceof String)) return "";
    else if (_tags.length == 0) return _html.replace(/<(\s*\/?)[^>]+>/g, "");
    else {
        var _re = new RegExp("<(?!(" + _tags.join("|") + ")\s*\/?)[^>]+>", "g");
        return _html.replace(_re, '');
    }
}


function raychat_linkify(inputText) {
    var replacedText, replacePattern1, replacePattern2, replacePattern3;

    //URLs starting with http://, https://, or ftp://
    replacePattern1 = /(\b(https?|ftp):\/\/[-A-Z0-9+&@#\/%?=~_|!:,.;]*[-A-Z0-9+&@#\/%=~_|])/gim;
    replacedText = inputText.replace(replacePattern1, '<a href="$1" class="raychat_message_href" target="_blank">$1</a>');

    //URLs starting with "www." (without // before it, or it'd re-link the ones done above).
    replacePattern2 = /(^|[^\/])(www\.[\S]+(\b|$))/gim;
    replacedText = replacedText.replace(replacePattern2, '$1<a href="http://$2" class="raychat_message_href" target="_blank">$2</a>');

    //Change email addresses to mailto:: links.
    replacePattern3 = /(([a-zA-Z0-9\-\_\.])+@[a-zA-Z\_]+?(\.[a-zA-Z]{2,6})+)/gim;
    replacedText = replacedText.replace(replacePattern3, '<a href="mailto:$1" class="raychat_message_href">$1</a>');

    return replacedText;
}

function raychat_htmlEntities(message) {

    return raychat_strip_tags(raychat_linkify(message), 'br', 'a');


    // return String(str).replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/>/g, '&gt;').replace(/"/g, '&quot;');
}

function raychat_find_urls(message) {
    // var geturl = new RegExp(
    //   "(^|[ \t\r\n])((ftp|http|https|gopher|mailto|news|nntp|telnet|wais|file|prospero|aim|webcal):(([A-Za-z0-9$_.+!*(),;/?:@&~=-])|%[A-Fa-f0-9]{2}){2,}(#([a-zA-Z0-9][a-zA-Z0-9$_.+!*(),;/?:@&~=%-]*))?([A-Za-z0-9$_+!*();/?:~-]))"
    //   ,"g"
    // );

    var uri_pattern = /\b((?:[a-z][\w-]+:(?:\/{1,3}|[a-z0-9%])|www\d{0,3}[.]|[a-z0-9.\-]+[.][a-z]{2,4}\/)(?:[^\s()<>]+|\(([^\s()<>]+|(\([^\s()<>]+\)))*\))+(?:\(([^\s()<>]+|(\([^\s()<>]+\)))*\)|[^\s`!()\[\] {};: '".,<>?«»“”‘’]))/ig;


    return message.match(uri_pattern);
}

function raychat_extract_hostname(url) {
    var hostname;
    //find & remove protocol (http, ftp, etc.) and get hostname

    if (url.indexOf("://") > -1) {
        hostname = url.split('/')[2];
    } else {
        hostname = url.split('/')[0];
    }

    //find & remove port number
    hostname = hostname.split(':')[0];
    //find & remove "?"
    hostname = hostname.split('?')[0];

    return hostname;
}


/**
 * recive URL return with protocol
 * @param {*String} url
 */
function raychat_concat_protocol_to_url(url) {

    if (url.indexOf("://") == -1) {
        return "http://" + url;
    } else {
        return url
    }
}




function raychat_get_url_preview(url, targetChat, chatId, readyResponse) {

    if (readyResponse) {

        readyResponse.targetChat = chatId;
        readyResponse.mainUrl = url;
        raychat_get_url_preview_html(readyResponse)
        return;
    }

    var linkPreviewData = {
        url: url,
        token: tdata.token,
        chatId: chatId
    }

    io.socket.post(pubsub + "/linkPreview", linkPreviewData, function (resData, result) {
        if (result.statusCode == 200) {
            if (document.getElementById(targetChat) && document.getElementById(targetChat).getElementsByClassName('raychat_link_preview')[0]) {
                resData.mainUrl = url;
                resData.targetChat = targetChat;
                raychat_get_url_preview_html(resData)
            }
        }
    });

}

function raychat_get_url_preview_html(resData) {

    var content;
    if (resData.image) {


        var raychat_image_tester = new Image();

        /**
         * test image url is valid or not
         */
        raychat_image_tester.onload = function () {
            content = '<div class="raychat_link_preview_thumnail"><img src="' + resData.image + '"></div><div class="raychat_link_preview_content"><h4>' + resData.title + '</h4><p>' + resData.description + '</p><span><a target="_blank" href="' + resData.mainUrl + '" title="' + resData.mainUrl + '">' + raychat_extract_hostname(resData.mainUrl) + '</a></span></div>'
            document.getElementById(resData.targetChat).getElementsByClassName('raychat_link_preview')[0].innerHTML = content;

        };
        raychat_image_tester.onerror = function () {
            content = '<div class="raychat_link_preview_content" style="width: 100% !important; padding-right: 4px;"><h4 style="text-align: center">' + resData.title + '</h4><p style="text-align: center">' + resData.description + '</p><span><a target="_blank" href="' + resData.mainUrl + '" title="' + resData.mainUrl + '">' + raychat_extract_hostname(resData.mainUrl) + '</a></span></div>'
            document.getElementById(resData.targetChat).getElementsByClassName('raychat_link_preview')[0].innerHTML = content;

        };


        raychat_image_tester.src = resData.image;

    } else {
        content = '<div class="raychat_link_preview_content" style="width: 100% !important; padding-right: 4px;"><h4 style="text-align: center">' + resData.title + '</h4><p style="text-align: center">' + resData.description + '</p><span><a target="_blank" href="' + resData.mainUrl + '" title="' + resData.mainUrl + '">' + raychat_extract_hostname(resData.mainUrl) + '</a></span></div>'
        document.getElementById(resData.targetChat).getElementsByClassName('raychat_link_preview')[0].innerHTML = content;

    }
    scrollTo(s, s.scrollHeight, 200);

}

function snd(msg, isEmoji) {


    // check for length
    if (msg.length === 0 || !msg.trim()) {
        return;
    }
    if (!isEmoji) {
        if (msg.length > 3428) {
            return;
        }
    }

    raychat_submit_sound.play();
    var tmpId = Math.random().toString(36).substring(7);


    var content;
    var messageUrls;
    var firstUrl;
    if (isEmoji) {
        content = '<div id="' + tmpId + '" class="raychat_main_container_body_chat_item raychat_main_container_body_chat_me fadeInUp raychat_animated"><div class="raychat_main_container_body_chat_me_emoji raychat_noselect">' + msg + '<span class="raychat_main_container_body_chat_me_emoji_status raychat_noselect"><img src="' + webAppUrl + '/widget/images/Sending.png"></span></div></div>';
    } else {


        if (msg.substr(0, 21) == "00raychat:data:image0") {


            content = '<div id="' + tmpId + '" class="raychat_main_container_body_chat_item raychat_main_container_body_chat_me fadeInUp raychat_animated"><div class="raychat_main_container_body_chat_item_message_me raychat_main_container_body_chat_item_message_me_uploaded_image"><img class="raychat_main_container_user_uploaded_pic" onclick="raychat_open_image(this)" src="' + msg.substring(22, msg.length) + '"/><span class="raychat_main_container_body_chat_item_message_me_uploaded_image_status raychat_noselect">' + widget.lang.sending + '</span></div></div>';


        } else {

            if (raychat_find_urls(msg)) {
                messageUrls = raychat_find_urls(msg)
                firstUrl = messageUrls[0];
                firstUrl = raychat_concat_protocol_to_url(firstUrl);

                content = '<div id="' + tmpId + '" class="raychat_main_container_body_chat_item raychat_main_container_body_chat_me fadeInUp raychat_animated"><div class="raychat_main_container_body_chat_item_message_me raychat_bgc">' + raychat_htmlEntities(msg) + '<div class="raychat_link_preview"><a href="' + firstUrl + '" target="_blank" title="' + firstUrl + '">' + raychat_extract_hostname(messageUrls[0]) + '</a></div><span class="raychat_main_container_body_chat_item_message_me_status raychat_main_container_body_chat_item_message_me_status_' + widget.lang.direction + ' raychat_noselect"><img src="' + webAppUrl + '/widget/images/Sending.png"></span></div></div>';

            } else {
                content = '<div id="' + tmpId + '" class="raychat_main_container_body_chat_item raychat_main_container_body_chat_me fadeInUp raychat_animated"><div class="raychat_main_container_body_chat_item_message_me raychat_bgc">' + raychat_htmlEntities(msg) + '<span class="raychat_main_container_body_chat_item_message_me_status raychat_main_container_body_chat_item_message_me_status_' + widget.lang.direction + ' raychat_noselect"><img src="' + webAppUrl + '/widget/images/Sending.png"></span></div></div>';

            }



        }

    }
    document.getElementById('raychat_main_container_body_chat').insertAdjacentHTML('beforeend', content);
    scrollTo(s, s.scrollHeight, 200);



    tdata.id = raychat_local_storage.getItem("rayToken");
    tdata.msg = msg;
    tdata.href = window.location.href;
    tdata.tmpId = tmpId;
    io.socket.post(pubsub + "/floatChat", tdata, function (resData, jwres) {
        if (resData.status == 1) {
            document.getElementById(resData.tmpId).getElementsByTagName('span')[0].getElementsByTagName('img')[0].src = webAppUrl + "/widget/images/exclamation.png"
        } else if (resData.status === 2) {
            document.getElementById(resData.tmpId).getElementsByTagName('span')[0].getElementsByTagName('img')[0].src = webAppUrl + "/widget/images/exclamation.png"
        } else {
            document.getElementById(resData.tmpId).getElementsByTagName('span')[0].getElementsByTagName('img')[0].src = webAppUrl + "/widget/images/sent.png"
            raychat_delivered_sound.play();





            if (messageUrls && firstUrl) {
                raychat_get_url_preview(firstUrl, tmpId, resData.chatId)
            }
        }


    });
}


function sendMedia(fileId, type, tmpId, moreData) {

    raychat_submit_sound.play();





    var neededData = {
        'token': document.getElementById('raychat_scripts').getAttribute('token'),
        'id': raychat_local_storage.getItem("rayToken"),
        'msg': fileId,
        'type': type,
        'href': window.location.href,
        'tmpId': tmpId,
        'moreData': moreData
    }



    io.socket.post(pubsub + "/floatChat", neededData, function (resData, jwres) {
        if (resData.status == 1) {
            document.getElementById(resData.tmpId).getElementsByClassName('raychat_main_container_body_chat_item_message_me_uploaded_image_status')[0].innerHTML = widget.lang.messageNotSend;
        } else if (resData.status === 2) {
            document.getElementById(resData.tmpId).getElementsByClassName('raychat_main_container_body_chat_item_message_me_uploaded_image_status')[0].innerHTML = widget.lang.formIsEmpty + widget.lang.messageNotSend;
        } else {
            document.getElementById(resData.tmpId).getElementsByClassName('raychat_main_container_body_chat_item_message_me_uploaded_image_status')[0].innerHTML = moreData.name || ''
            raychat_delivered_sound.play();

        }


    });
}

function raychat_open_image(thisnode) {


    var image = thisnode.getAttribute('src');
    var imageHeight = parent.window.innerHeight - 100;
    var scrollTopPositionValue = parent.window.pageYOffset || parent.document.documentElement.scrollTop || parent.document.body.scrollTop || 0;
    scrollTopPositionValue += 40;


    var scrollHeightValue = parent.window.document.body.scrollHeight;

    if (window.parent.document.getElementById('raychat_open_modal')) {
        window.parent.document.getElementById('raychat_open_modal').className += " active";
        window.parent.document.getElementById('raychat_open_modal').innerHTML = '<div><img class="raychat_zoomIn raychat_noselect raychat_animated-fast" src="' + image + '" style="height: ' + imageHeight + 'px; margin: ' + scrollTopPositionValue + 'px 0;"></div>';
    } else {
        var content = '<div class="raychat_open_modal raychat_noselect active" id="raychat_open_modal"><div><img class="raychat_zoomIn raychat_noselect raychat_animated-fast" src="' + image + '" style="height: ' + imageHeight + 'px; margin: ' + scrollTopPositionValue + 'px 0;"></div></div>';
        window.parent.document.getElementsByTagName('body')[0].insertAdjacentHTML('beforeend', content);
    }

    window.parent.document.getElementById('raychat_open_modal').style.height = scrollHeightValue + "px";
    parent.window.document.body.style.overflow = "hidden";


    window.parent.document.getElementById('raychat_open_modal').addEventListener('click', function (e) {
        window.parent.document.getElementById('raychat_open_modal').classList.remove('active');
        parent.window.document.body.style.removeProperty('overflow');
    })

}

function raychat_append_media(file, data, type, addToTop, agent) {

    var isSending = file.id ? false : true;
    var id;
    var position = addToTop ? 'afterbegin' : 'beforeend'

    if (isSending) {
        id = Math.random().toString(36).substring(7);

    } else {

        id = file.id
        file.name = file.meta.name
        file.size = file.meta.size
        file.accessibleSize = file.meta.accessibleSize

    }



    var content;
    var status = isSending ? widget.lang.sending : file.name;
    var downloadUrl = isSending ? data : cdnUrl + file.message;


    var isUserMessage = agent ? false : true;
    switch (type) {
        case 0:
            var size = isSending ? '' : '?size=' + file.accessibleSize
            if (isUserMessage) {
                content = '<div id="' + id + '" class="raychat_main_container_body_chat_item raychat_main_container_body_chat_me fadeInUp raychat_animated"><div class="raychat_main_container_body_chat_item_message_me raychat_main_container_body_chat_item_message_me_uploaded_image"><img class="raychat_main_container_user_uploaded_pic" onclick="raychat_open_image(this)" src="' + data + size + '"/><span class="raychat_main_container_body_chat_item_message_me_uploaded_image_status raychat_noselect">' + status + '</span></div></div>';
            } else {
                content = '<div id="' + id + '" class="raychat_main_container_body_chat_item raychat_main_container_body_chat_agent fadeInUp raychat_animated"><div class="raychat_main_container_body_chat_item_avatar" style="background-image: ' + agent.avatar + ' "></div><div class="raychat_main_container_body_chat_item_message_agent raychat_main_container_body_chat_item_message_agent_uploaded_image"><img class="raychat_main_container_user_uploaded_pic" onclick="raychat_open_image(this)" src="' + data + size + '"/><span class="raychat_main_container_body_chat_item_message_agent_uploaded_image_status raychat_noselect">' + status + '</span></div></div>';
            }
            break
        case 1:
            if (isUserMessage) {
                content = "<div id=\"" + id + "\" class=\"raychat_main_container_body_chat_item raychat_main_container_body_chat_me fadeInUp raychat_animated\">\n        <div class=\"raychat_main_container_body_chat_item_message_me raychat_main_container_body_chat_item_message_me_uploaded_media\"><video controls>\n            <source src=\"" + data + "\" type=\"video/mp4\">\n            <source src=\"" + data + "\" type=\"video/ogg\">\n            Your browser does not support the video tag.\n          </video><span class=\"raychat_main_container_body_chat_item_message_me_uploaded_image_status raychat_noselect\">" + status + "</span></div></div>";
            } else {
                content = "<div id=\"" + id + "\" class=\"raychat_main_container_body_chat_item raychat_main_container_body_chat_agent fadeInUp raychat_animated\">\n        <div class=\"raychat_main_container_body_chat_item_avatar\" style=\"background-image: " + agent.avatar + " \"></div>\n        <div class=\"raychat_main_container_body_chat_item_message_agent raychat_main_container_body_chat_item_message_agent_uploaded_media\">\n        <video controls>\n            <source src=\"" + data + "\" type=\"video/mp4\">\n            <source src=\"" + data + "\" type=\"video/ogg\">\n            Your browser does not support the video tag.\n          </video><span class=\"raychat_main_container_body_chat_item_message_agent_uploaded_image_status raychat_noselect\">" + status + "</span></div></div>";
            }


            break
        case 2:

            if (isUserMessage) {
                content = "<div id=\"" + id + "\" class=\"raychat_main_container_body_chat_item raychat_main_container_body_chat_me fadeInUp raychat_animated\">\n        <div class=\"raychat_main_container_body_chat_item_message_me raychat_main_container_body_chat_item_message_me_uploaded_media\">\n        <audio controls style=\"margin-right: -15px;\">\n            <source src=\"" + data + "\" type=\"audio/ogg\">\n            <source src=\"" + data + "\" type=\"audio/mpeg\">\n          Your browser does not support the audio element.\n          </audio><span class=\"raychat_main_container_body_chat_item_message_me_uploaded_image_status raychat_noselect\">" + status + "</span></div></div>";
            } else {
                content = "<div id=\"" + id + "\" class=\"raychat_main_container_body_chat_item raychat_main_container_body_chat_agent fadeInUp raychat_animated\">\n        <div class=\"raychat_main_container_body_chat_item_avatar\" style=\"background-image: " + agent.avatar + "\"></div>\n        <div class=\"raychat_main_container_body_chat_item_message_agent raychat_main_container_body_chat_item_message_agent_uploaded_media\">\n        <audio controls style=\"margin: 0 0 -13px -10px;\">\n            <source src=\"" + data + "\" type=\"audio/ogg\">\n            <source src=\"" + data + "\" type=\"audio/mpeg\">\n          Your browser does not support the audio element.\n          </audio><span class=\"raychat_main_container_body_chat_item_message_agent_uploaded_image_status raychat_noselect\">" + status + "</span></div></div>";
            }


            break
        case 3:

            if (isUserMessage) {
                content = "<div id=\"" + id + "\" class=\"raychat_main_container_body_chat_item raychat_main_container_body_chat_me fadeInUp raychat_animated\">\n        <div class=\"raychat_main_container_body_chat_item_message_me raychat_main_container_body_chat_item_message_me_uploaded_media\">\n\n      <div class=\"raychat_file_div\">\n        <div class=\"raychat_file_icon\">\n          <a target=\"_blank\" href=\"" + downloadUrl + "\"><img src=\"" + webAppUrl + "/widget/images/download.png\"></a>\n        </div>\n        <div class=\"raychat_file_name\">" + file.name + "<br>\n        <span class=\"raychat_file_size\">" + bytesToSize(file.size) + "</span>\n        </div>\n      </div>\n\n      <span class=\"raychat_main_container_body_chat_item_message_me_uploaded_image_status raychat_noselect\">" + status + "</span></div></div>";
            } else {
                content = "<div id=\"" + id + "\" class=\"raychat_main_container_body_chat_item raychat_main_container_body_chat_agent fadeInUp raychat_animated\">\n        <div class=\"raychat_main_container_body_chat_item_avatar\" style=\"background-image: " + agent.avatar + " \"></div>\n\n      <div class=\"raychat_main_container_body_chat_item_message_agent raychat_main_container_body_chat_item_message_agent_uploaded_media\">\n\n      <div class=\"raychat_file_div\">\n        <div class=\"raychat_file_icon\">\n          <a target=\"_blank\" href=\"" + downloadUrl + "\"><img src=\"" + webAppUrl + "/widget/images/download.png\"></a>\n        </div>\n        <div class=\"raychat_file_name\">" + file.name + "<br>\n        <span class=\"raychat_file_size\">" + bytesToSize(file.size) + "</span>\n        </div>\n      </div>\n\n      </div></div>";
            }
            break
        case 4:

            if (isUserMessage) {
                content = "<div id=\"" + id + "\" class=\"raychat_main_container_body_chat_item raychat_main_container_body_chat_me fadeInUp raychat_animated\">\n        <div class=\"raychat_main_container_body_chat_item_message_me raychat_main_container_body_chat_item_message_me_uploaded_media\">\n\n      <div class=\"raychat_file_div\">\n        <div class=\"raychat_file_icon\">\n          <a target=\"_blank\" href=\"" + downloadUrl + "\"><img src=\"" + webAppUrl + "/widget/images/download.png\"></a>\n        </div>\n        <div class=\"raychat_file_name\">" + file.name + "<br>\n        <span class=\"raychat_file_size\">" + bytesToSize(file.size) + "</span>\n        </div>\n      </div>\n\n      <span class=\"raychat_main_container_body_chat_item_message_me_uploaded_image_status raychat_noselect\">" + status + "</span></div></div>";
            } else {
                content = "<div id=\"" + id + "\" class=\"raychat_main_container_body_chat_item raychat_main_container_body_chat_agent fadeInUp raychat_animated\">\n        <div class=\"raychat_main_container_body_chat_item_avatar\" style=\"background-image: " + agent.avatar + " \"></div>\n\n      <div class=\"raychat_main_container_body_chat_item_message_agent raychat_main_container_body_chat_item_message_agent_uploaded_media\">\n\n      <div class=\"raychat_file_div\">\n        <div class=\"raychat_file_icon\">\n          <a target=\"_blank\" href=\"" + downloadUrl + "\"><img src=\"" + webAppUrl + "/widget/images/download.png\"></a>\n        </div>\n        <div class=\"raychat_file_name\">" + file.name + "<br>\n        <span class=\"raychat_file_size\">" + bytesToSize(file.size) + "</span>\n        </div>\n      </div>\n\n      </div></div>";
            }
            break
    }
    document.getElementById('raychat_main_container_body_chat').insertAdjacentHTML(position, content);

    if (!addToTop) {
        scrollTo(s, s.scrollHeight, 200);
    } else {
        s.scrollTop = addToTop.offsetTop - 22
    }

    return id
}

function raychat_upload(file, data, type) {

    if (file) {


        document.getElementById('raychat_main_textarea').placeholder = widget.lang.uploadingMedia;


        var tmpId = raychat_append_media(file, data, type, false)



        var formData = new FormData();
        formData.append('uploader', raychat_local_storage.getItem("rayToken"));
        formData.append('file', file, file.name);
        var xhr = new XMLHttpRequest();
        xhr.open('post', cdnUrl + 'upload', true);
        xhr.send(formData);




        xhr.onreadystatechange = function () {
            if (xhr.readyState === 4) {



                var response = JSON.parse(xhr.responseText);

                if (response && response.success) {
                    var moreData = {
                        name: response.name,
                        size: response.size
                    }
                    if (type == 0) {
                        moreData.accessibleSize = response.large ? 'large' : 'medium'

                        if (!response.medium) moreData.accessibleSize = 'small'
                    }
                    sendMedia(response.id, type, tmpId, moreData)


                } else {
                    document.getElementById(tmpId).getElementsByClassName('raychat_main_container_body_chat_item_message_me_uploaded_image_status')[0].innerHTML = widget.lang.messageNotSend;
                }
                document.getElementById('raychat_main_textarea').placeholder = widget.lang.sendMessage;






            }
        };
        xhr.onprogress = function (e) {
            if (e.lengthComputable) {
                var percentComplete = (e.loaded / e.total) * 100;
                document.getElementById('raychat_main_textarea').placeholder = widget.lang.uploadingMedia + " (" + percentComplete + "%)"
            }
        }



    }

}

function raychat_what_is_this_file(file) {
    var type = file.type;
    var images = ['image/webp', //.webp
        'image/png', //.png
        'image/svg+xml', //.svg
        'image/jpeg', //.jpeg .jpg
        'image/gif', //.gif
    ],
        videos = [
            'video/3gpp',
            'video/ogg',
            'video/mp4',
            'video/mpeg',
            'video/quicktime',
            'video/webm',
            'video/x-ms-wmv',
            'video/x-msvideo',
        ],
        audios = [
            'audio/mp3', //.mp3
            'audio/ogg', //.ogg
            'audio/mpeg',
            'audio/x-m4a',

        ],
        compresseds = [
            'application/x-zip-compressed', //.zip
            'application/x-rar-compressed', //.tar
            'application/zip', //.zip
            'application/x-zip-compressed', //.zip
            'application/x-tar', //.tar
            'application/x-7z-compressed'
        ],
        documents = [
            'application/pdf',
            'application/vnd.ms-excel', //.csv
            'application/msword', //.doc
            'application/vnd.openxmlformats-officedocument.wordprocessingml.document', //.docx
            'application/rtf', //.rtf
            'application/vnd.ms-powerpoint',
        ];

    if (images.indexOf(type) != -1) {
        return 0
    } else if (videos.indexOf(type) != -1) {
        return 1
    } else if (audios.indexOf(type) != -1) {
        return 2
    } else if (compresseds.indexOf(type) != -1) {
        return 3
    } else if (documents.indexOf(type) != -1) {
        return 4
    }

}


function raychat_open_verify(file) {

    var pageStarted = parent.window.scrollY
    var mediaHeight = parent.window.innerHeight - 100;


    var raychat_open_modal_el = window.parent.document.getElementById('raychat_open_modal');
    if (raychat_open_modal_el) raychat_open_modal_el.parentNode.removeChild(raychat_open_modal_el);


    var fileType = raychat_what_is_this_file(file)
    var parentInnerHeight = parent.window.innerHeight;
    var fileData = '';



    var content = "\n    <div class=\"raychat_open_modal raychat_noselect active\" id=\"raychat_open_modal\">\n      <div>\n        <div id=\"raychat_modal_content\" style='margin-top: " + pageStarted + "px'></div>\n        <div class=\"raychat_btn_set\">\n          <button class=\"raychat_btn_set_deny\">\n          </button><button class=\"raychat_btn_set_accept\"></button>\n        </div>\n\n      </div>\n    </div>";
    window.parent.document.getElementsByTagName('body')[0].insertAdjacentHTML('beforeend', content);



    var marginTop = (parentInnerHeight - 210) / 2
    var content = "<img class=\"raychat_zoomIn raychat_noselect raychat_animated-fast raychat_media_loader\" \n  src=\"" + webAppUrl + "/widget/images/widget-loader.gif\" id=\"raychat_media_loader\" style=\"margin-top: " + marginTop + "px !important\" >";
    window.parent.document.getElementById('raychat_modal_content').insertAdjacentHTML('beforeend', content);
    var elem = window.parent.document.getElementById('raychat_media_loader');

    var scrollHeightValue = parent.window.document.body.scrollHeight;
    window.parent.document.getElementById('raychat_open_modal').style.height = scrollHeightValue + "px";




    fileData = URL.createObjectURL(file);

    switch (fileType) {

        case 0: // image files preview


            // remove loader

            elem.parentNode.removeChild(elem);

            content = '<img class="raychat_zoomIn raychat_noselect raychat_animated-fast" src="' + fileData + '" style="height: ' + mediaHeight + 'px" >'; //style="height: ' + imageHeight + 'px; margin: ' + scrollTopPositionValue + 'px 0 0;"
            window.parent.document.getElementById('raychat_modal_content').insertAdjacentHTML('beforeend', content);


            break

        case 1: // video files preview
            // remove loader
            elem.parentNode.removeChild(elem);

            content = "<video controls style='height:" + mediaHeight + "px !important;'>\n      <source src=\"" + fileData + "\" type=\"video/mp4\">\n      <source src=\"" + fileData + "\" type=\"video/ogg\">\n      Your browser does not support the video tag.\n    </video>";

            window.parent.document.getElementById('raychat_modal_content').insertAdjacentHTML('beforeend', content);
            break

        case 2: // audio files preview
            marginTop = (parentInnerHeight - 131) / 2
            elem.parentNode.removeChild(elem);

            content = "<audio controls style=\"margin-top:" + marginTop + "px\">\n          <source src=\"" + fileData + "\" type=\"audio/ogg\">\n          <source src=\"" + fileData + "\" type=\"audio/mpeg\">\n        Your browser does not support the audio element.\n        </audio>";

            window.parent.document.getElementById('raychat_modal_content').insertAdjacentHTML('beforeend', content);
            break

        case 3: // compresseds files preview

            // remove loader
            elem.parentNode.removeChild(elem);

            marginTop = (parentInnerHeight - 168) / 2


            content = "<div class=\"raychat_file_div\" style=\"margin-top: " + marginTop + "px\">\n        <div class=\"raychat_file_icon\"><img src=\"" + webAppUrl + "/widget/images/Folder-Zip-icon.png\"></div>\n        <div class=\"raychat_file_name\">" + file.name + "<br>\n        <span class=\"raychat_file_size\">" + bytesToSize(file.size) + "</span>\n        </div>\n        \n      </div>\n      ";

            window.parent.document.getElementById('raychat_modal_content').insertAdjacentHTML('beforeend', content);

            break

        case 4: // documents files preview

            // remove loader
            elem.parentNode.removeChild(elem);

            marginTop = (parentInnerHeight - 168) / 2

            content = "<div class=\"raychat_file_div\" style=\"margin-top: " + marginTop + "px\">\n        <div class=\"raychat_file_icon\"><img src=\"" + webAppUrl + "/widget/images/document-icon.png\"></div>\n        <div class=\"raychat_file_name\">" + file.name + "<br>\n        <span class=\"raychat_file_size\">" + bytesToSize(file.size) + "</span>\n        </div>\n        \n      </div>\n      ";

            window.parent.document.getElementById('raychat_modal_content').insertAdjacentHTML('beforeend', content);

            break
    }











    // var image = imageData;
    var scrollTopPositionValue = parent.window.pageYOffset || parent.document.documentElement.scrollTop || parent.document.body.scrollTop || 0;
    scrollTopPositionValue += 40;




    // if (window.parent.document.getElementById('raychat_open_modal')) {
    //   window.parent.document.getElementById('raychat_open_modal').className += " active";
    //   window.parent.document.getElementById('raychat_open_modal').innerHTML = '<div><img class="raychat_zoomIn raychat_noselect raychat_animated-fast" src="' + image + '" style="height: ' + imageHeight + 'px; margin: ' + scrollTopPositionValue + 'px 0 0;"><div class="raychat_btn_set"><button class="raychat_btn_set_deny"></button><button class="raychat_btn_set_accept"></button></div></div>';
    // }
    // else {
    //   var content = '<div class="raychat_open_modal raychat_noselect active" id="raychat_open_modal"><div><img class="raychat_zoomIn raychat_noselect raychat_animated-fast" src="' + image + '" style="height: ' + imageHeight + 'px; margin: ' + scrollTopPositionValue + 'px 0 0;"><div class="raychat_btn_set"><button class="raychat_btn_set_deny"></button><button class="raychat_btn_set_accept"></button></div></div></div>';
    //   window.parent.document.getElementsByTagName('body')[0].insertAdjacentHTML('beforeend', content);
    // }

    parent.window.document.body.style.overflow = "hidden";



    window.parent.document.getElementById('raychat_open_modal').addEventListener('click', function (e) {
        if (e.target.className.match(/\braychat_btn_set_accept\b/)) {
            raychat_upload(file, fileData, fileType);
            raychat_open_modal_el = window.parent.document.getElementById('raychat_open_modal');
            if (raychat_open_modal_el) raychat_open_modal_el.parentNode.removeChild(raychat_open_modal_el);

            // window.parent.document.getElementById('raychat_open_modal').classList.remove('active');
            parent.window.document.body.style.removeProperty('overflow');
            file = "";
        }

        if (e.target.className.match(/\braychat_btn_set_deny\b/)) {
            raychat_open_modal_el = window.parent.document.getElementById('raychat_open_modal');
            if (raychat_open_modal_el) raychat_open_modal_el.parentNode.removeChild(raychat_open_modal_el);

            // window.parent.document.getElementById('raychat_open_modal').classList.remove('active');
            parent.window.document.body.style.removeProperty('overflow');
            file = "";
        }


    })

}

function bytesToSize(bytes) {
    var sizes = ['Bytes', 'KB', 'MB', 'GB', 'TB'];
    if (bytes == 0) return '0 Byte';
    var i = parseInt(Math.floor(Math.log(bytes) / Math.log(1024)));
    return Math.round(bytes / Math.pow(1024, i), 2) + ' ' + sizes[i];
};

function appendMsg(msg, message, addToTop) {



    // check for length
    if (msg.length === 0 || !msg.trim()) {
        return;
    }

    var content;
    var messageId

    if (message) {
        var messageId = message.id || '';
    }


    if (message.type) {

        raychat_append_media(message, cdnUrl + msg, parseInt(message.type), addToTop)
        return;
    }

    if (msg.substr(0, 21) == "00raychat:data:image0") {


        content = '<div id="' + messageId + '" class="raychat_main_container_body_chat_item raychat_main_container_body_chat_me fadeInUp raychat_animated"><div class="raychat_main_container_body_chat_item_message_me raychat_main_container_body_chat_item_message_me_uploaded_image"><img class="raychat_main_container_user_uploaded_pic" onclick="raychat_open_image(this)" src="' + msg.substring(22, msg.length) + '"/><span class="raychat_main_container_body_chat_item_message_agent_status raychat_noselect"></span></div></div>';
        if (!addToTop) {
            document.getElementById('raychat_main_container_body_chat').insertAdjacentHTML('beforeend', content);
        } else {
            document.getElementById('raychat_main_container_body_chat').insertAdjacentHTML('afterbegin', content);
        }

    } else {

        if (raychat_find_urls(msg)) {
            var messageUrls = raychat_find_urls(msg)
            var firstUrl = messageUrls[0];
            firstUrl = raychat_concat_protocol_to_url(firstUrl);
            content = '<div id="' + messageId + '" class="raychat_main_container_body_chat_item raychat_main_container_body_chat_me fadeInUp raychat_animated"><div class="raychat_main_container_body_chat_item_message_me raychat_bgc">' + raychat_htmlEntities(msg) + '<div class="raychat_link_preview"><a href="' + firstUrl + '" target="_blank" title="' + firstUrl + '">' + raychat_extract_hostname(messageUrls[0]) + '</a></div><span class="raychat_main_container_body_chat_item_message_me_status raychat_main_container_body_chat_item_message_me_status_' + widget.lang.direction + ' raychat_noselect"></span></div></div>';
            if (!addToTop) {
                document.getElementById('raychat_main_container_body_chat').insertAdjacentHTML('beforeend', content);
            } else {
                document.getElementById('raychat_main_container_body_chat').insertAdjacentHTML('afterbegin', content);
            }
            raychat_get_url_preview(firstUrl, messageId, messageId, message.meta.linkPreview)

        } else {
            content = '<div id="' + messageId + '" class="raychat_main_container_body_chat_item raychat_main_container_body_chat_me fadeInUp  raychat_animated"> <div class="raychat_main_container_body_chat_item_message_me raychat_bgc">' + raychat_htmlEntities(msg) + '<span class="raychat_main_container_body_chat_item_message_me_status raychat_main_container_body_chat_item_message_me_status_' + widget.lang.direction + ' raychat_noselect"></span></div></div>';
            if (!addToTop) {
                document.getElementById('raychat_main_container_body_chat').insertAdjacentHTML('beforeend', content);
            } else {
                document.getElementById('raychat_main_container_body_chat').insertAdjacentHTML('afterbegin', content);
            }
        }
    }

    if (!addToTop) {
        scrollTo(s, s.scrollHeight, 200);
    } else {
        s.scrollTop = addToTop.offsetTop - 22
    }



    if (document.getElementsByClassName("raychat_main_container_body_chat_item_typing")) {
        document.getElementsByClassName("raychat_main_container_body_chat_item_typing").remove();
    }



}


function appendMsgAgent(msg, agent_avatar, agent_id, messageId, isThisFunctionCalledOnEvent, messageChatObj, addToTop) {






    // check for length
    if (!msg || msg.length === 0 || !msg.trim()) {
        return;
    }

    var onlineAgentsCount = 0;
    var content;
    var agentAvatar;


    if (agent_avatar) {
        agentAvatar = "url('" + webAppUrl + "/" + agent_avatar + "');";
        onlineAgentsCount++;
    } else {

        if (document.getElementById('raychat_scripts').getAttribute('raychat_onlineAgents') !== "" && document.getElementById('raychat_scripts').getAttribute('raychat_onlineAgents')) {
            agentAvatar = "url('" + webAppUrl + document.getElementById('raychat_scripts').getAttribute('raychat_onlineAgents') + "')";
            onlineAgentsCount++;
        }
    }


    if (onlineAgentsCount == 0) {
        agentAvatar = "url('" + webAppUrl + "/" + raychat_local_storage.getItem('raychat_channel_photo') + "')";
    }



    if (messageChatObj && messageChatObj.type) {

        var agent = {
            avatar: agentAvatar
        }
        raychat_append_media(messageChatObj, cdnUrl + msg, parseInt(messageChatObj.type), addToTop, agent)
        return;
    }





    var chatId = messageId || '';

    if (msg.substr(0, 21) == "00raychat:data:image0") {
        content = '<div id="' + chatId + '" class="raychat_main_container_body_chat_item raychat_main_container_body_chat_agent fadeInUp raychat_animated"><div class="raychat_main_container_body_chat_item_avatar" style="background-image: ' + agentAvatar + ' "></div><div class="raychat_main_container_body_chat_item_message_agent raychat_main_container_body_chat_item_message_agent_uploaded_image"><img class="raychat_main_container_user_uploaded_pic" onclick="raychat_open_image(this)" src="' + webAppUrl + '/' + msg.substring(22, msg.length) + '"/><span class="raychat_main_container_body_chat_item_message_agent_status raychat_noselect"></span></div></div>';
        if (!addToTop) {
            document.getElementById('raychat_main_container_body_chat').insertAdjacentHTML('beforeend', content);
        } else {
            document.getElementById('raychat_main_container_body_chat').insertAdjacentHTML('afterbegin', content);
        }
    } else {



        if (raychat_find_urls(msg)) {
            var messageUrls = raychat_find_urls(msg)
            var firstUrl = messageUrls[0];
            firstUrl = raychat_concat_protocol_to_url(firstUrl);
            content = '<div id="' + chatId + '" class="raychat_main_container_body_chat_item raychat_main_container_body_chat_agent fadeInUp raychat_animated"><div class="raychat_main_container_body_chat_item_avatar" style="background-image:' + agentAvatar + ' "></div><div class="raychat_main_container_body_chat_item_message_agent">' + raychat_htmlEntities(msg) + '<div class="raychat_link_preview"><a href="' + firstUrl + '" target="_blank" title="' + firstUrl + '">' + raychat_extract_hostname(messageUrls[0]) + '</a></div><span class="raychat_main_container_body_chat_item_message_agent_status raychat_noselect"></span></div></div>';
            if (!addToTop) {
                document.getElementById('raychat_main_container_body_chat').insertAdjacentHTML('beforeend', content);
            } else {
                document.getElementById('raychat_main_container_body_chat').insertAdjacentHTML('afterbegin', content);
            }
            if (isThisFunctionCalledOnEvent) {
                raychat_get_url_preview(firstUrl, chatId, chatId);
            } else if (messageChatObj && messageChatObj.meta) {
                raychat_get_url_preview(firstUrl, chatId, chatId, messageChatObj.meta.linkPreview)
            }

        } else {
            content = '<div id="' + chatId + '" class="raychat_main_container_body_chat_item raychat_main_container_body_chat_agent fadeInUp raychat_animated"><div class="raychat_main_container_body_chat_item_avatar" style="background-image:' + agentAvatar + ' "></div><div class="raychat_main_container_body_chat_item_message_agent">' + raychat_htmlEntities(msg) + '<span class="raychat_main_container_body_chat_item_message_agent_status raychat_noselect"></span></div></div>';
            if (!addToTop) {
                document.getElementById('raychat_main_container_body_chat').insertAdjacentHTML('beforeend', content);
            } else {
                document.getElementById('raychat_main_container_body_chat').insertAdjacentHTML('afterbegin', content);
            }
        }

    }


    if (!addToTop) {
        scrollTo(s, s.scrollHeight, 200);
    } else {
        s.scrollTop = addToTop.offsetTop - 22
    }

    if (document.getElementsByClassName("raychat_main_container_body_chat_item_typing")) {
        document.getElementsByClassName("raychat_main_container_body_chat_item_typing").remove();
    }

}


function raychat_user_me_message_count() {
    return document.getElementsByClassName('raychat_main_container_body_chat_item_message_me').length;
}

function scrollTo(element, to, duration) {
    if (duration <= 0) return;
    var difference = to - element.scrollTop;
    var perTick = difference / duration * 10;

    setTimeout(function () {
        element.scrollTop = element.scrollTop + perTick;
        if (element.scrollTop === to) return;
        scrollTo(element, to, duration - 10);
    }, 10);
}

function raychat_open_emoji_list(thisnode) {




    if (!openedEmoji) {
        q.style.width = d.offsetWidth + "px"
        q.className += " active";
        thisnode.className += " active";
        openedEmoji = true;
    } else {
        q.classList.remove("active");
        thisnode.classList.remove("active");
        openedEmoji = false;
    }
}

function raychat_new_emoji(thisnode) {

    if (document.getElementById("raychat_main_textarea").value == 0) {
        snd(thisnode.innerHTML, true);
    } else {
        document.getElementById("raychat_main_textarea").value += thisnode.innerHTML;
    }


    i.focus();
    // check for length
    if (i.value.length != 0) {
        // if hasClass active
        if (!h.className.match(/\bactive\b/)) {
            h.className += " active";
        }
    } else {
        h.classList.remove("active");
    }
}

function raychat_agent_accept(agent) {

    n = agent.avatar;
    var agentName = agent.name;
    var isMessageShown = false;
    if (raychat_local_storage.getItem('raychat_agent_name') == null) {
        isMessageShown = true;
    }
    raychat_local_storage.setItem('raychat_agent_avatar', n);
    raychat_local_storage.setItem('raychat_agent_name', agentName);
    raychat_local_storage.setItem('raychat_agent_title', agent.title);
    raychat_local_storage.setItem('raychat_agent_id', agent.id);
    raychat_local_storage.setItem('raychat_conversationId', agent.conversationId);

    if (isMessageShown) {
        var content;
        content = '<div class="raychat_main_container_body_chat_item_toast_message raychat_zoomIn raychat_animated active raychat_noselect" id="raychat_main_container_body_chat_item_toast_message">' + agent.name + ' ' + widget.lang.acceptConversationWithYou + '</div>';
        document.getElementById('raychat_main_container_body_chat').insertAdjacentHTML('beforeend', content);
    }


    l.classList.remove("active");
    o.className += " active";


    x.getElementsByTagName('h3')[0].innerHTML = agentName;
    x.getElementsByTagName('p')[0].innerHTML = agent.title || '';

    x.getElementsByClassName('raychat_main_container_header_agents_1')[0].style.backgroundImage = "url('" + webAppUrl + agent.avatar + "')";
    scrollTo(s, s.scrollHeight, 200);
}

function raychat_agent_transfer(agent) {


    n = agent.targetAgentAvatar;
    var agentName = agent.targetAgentName;

    raychat_local_storage.setItem('raychat_agent_avatar', n);
    raychat_local_storage.setItem('raychat_agent_name', agentName);
    raychat_local_storage.setItem('raychat_agent_title', agent.targetAgentTitle);
    raychat_local_storage.setItem('raychat_agent_id', agent.targetAgentId);
    raychat_local_storage.setItem('raychat_conversationId', agent.conversationId);


    var content;
    content = '<div class="raychat_main_container_body_chat_item_toast_message raychat_zoomIn raychat_animated active raychat_noselect" id="raychat_main_container_body_chat_item_toast_message">' + widget.lang.transferConversation + agent.targetAgentName + '</div>';
    // content = '<div class="raychat_main_container_body_chat_item_toast_message raychat_zoomIn raychat_animated active raychat_noselect" id="raychat_main_container_body_chat_item_toast_message">' + agent.targetAgentName + ' تست</div>';
    document.getElementById('raychat_main_container_body_chat').insertAdjacentHTML('beforeend', content);


    l.classList.remove("active");
    o.className += " active";

    var agentsAvatar = document.getElementsByClassName('raychat_main_container_body_chat_item_avatar');

    for (var y = 0; y < agentsAvatar.length; y++) {

        // agentsAvatar[y].style.backgroundImage = "url('" + webAppUrl + agent.avatar + "')";

    }

    x.getElementsByTagName('h3')[0].innerHTML = agentName;
    x.getElementsByTagName('p')[0].innerHTML = agent.title || '';

    x.getElementsByClassName('raychat_main_container_header_agents_1')[0].style.backgroundImage = "url('" + webAppUrl + agent.targetAgentAvatar + "')";
    scrollTo(s, s.scrollHeight, 200);
}

function raychat_conversationClosed(dontSendNotificationToUser) {


    raychat_local_storage.remove('raychat_agent_avatar');
    raychat_local_storage.remove('raychat_agent_name');
    raychat_local_storage.remove('raychat_agent_title');
    raychat_local_storage.remove('raychat_agent_id');
    raychat_local_storage.remove('raychat_conversationId');

    if (!dontSendNotificationToUser) {
        var content;
        content = '<div class="raychat_main_container_body_chat_item_toast_message raychat_zoomIn raychat_animated active raychat_noselect" id="raychat_main_container_body_chat_item_toast_message">' + widget.lang.conversationClosed + '</div>';
        document.getElementById('raychat_main_container_body_chat').insertAdjacentHTML('beforeend', content);

        scrollTo(s, s.scrollHeight, 200);
    }




    o.classList.remove("active");
    l.className += " active";


    raychat_getAgents();
}

function raychat_toggle_spinner(bool) {
    if (bool) {
        m.className += " active";
    } else {
        m.classList.remove("active");
    }

}

function raychatCloseClicked() {
    raychat_responsive_in_iphone_close()

    opened = false;
    parent.raychat_close_container();
}

function raychat_reset_counter() {
    counter = 0;
}

function raychat_validate_email(email) {
    var re = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
    return re.test(email);
}

function raychat_validate_phone(phone) {
    var re = /^[\+]?[(]?[0-9]{3}[)]?[-\s\.]?[0-9]{3}[-\s\.]?[0-9]{4,6}$/im;
    return re.test(phone);
}

function raychat_setUser(user) {


    user.id = raychat_local_storage.getItem("rayToken");
    io.socket.post(pubsub + '/socket/userDetail', user, function (res) {

        if (res.success) {

            if (res.user) {

                if (document.getElementById('raychat_main_container_body_chat_item_message_agent_email_phone_form_body_email_val')) {
                    document.getElementById('raychat_main_container_body_chat_item_message_agent_email_phone_form_body_email_val').value = res.user.email;
                }

                if (document.getElementById('raychat_main_container_body_chat_item_message_agent_email_phone_form_body_phone_val')) {
                    document.getElementById('raychat_main_container_body_chat_item_message_agent_email_phone_form_body_phone_val').value = res.user.phone || '';
                }


                parent.Raychat.__profile_updated(res.user);
            }
        }
    });
}

function raychat_load_user(userId) {

    if (!userId) return


    if (tdata.id != userId) {


        raychat_floating_app_widget_init({ load: true, userId: userId })
    }

}

function raychat_unload_user() {


    raychat_local_storage.removeAll();
    localStorage.removeItem("rayToken");
    io.socket.disconnect();
    delete tdata.id


    // clearInterval(checkUserInterval)
    // visitorDetailsComplete = false;
    // io.socket.reconnect();
    // raychat_floating_app_widget_init({ load: false })


}

function raychat_send_email_add(thisnode) {


    delete tdata.tmpId;
    delete tdata.href;
    delete tdata.msg;
    tdata.id = raychat_local_storage.getItem("rayToken");

    if (document.getElementById('raychat_main_container_body_chat_item_message_agent_email_phone_form_body_email_val')) {
        if (document.getElementById('raychat_main_container_body_chat_item_message_agent_email_phone_form_body_email_val').value) {
            if (!raychat_validate_email(document.getElementById('raychat_main_container_body_chat_item_message_agent_email_phone_form_body_email_val').value)) {
                document.getElementById('raychat_user_more_details_response').className += " error";
                document.getElementById('raychat_user_more_details_response').classList.remove('success');
                document.getElementById('raychat_user_more_details_response').innerHTML = widget.lang.invalidEmail;
                return false;
            }

            tdata.email = document.getElementById('raychat_main_container_body_chat_item_message_agent_email_phone_form_body_email_val').value;

        }
    }
    if (document.getElementById('raychat_main_container_body_chat_item_message_agent_email_phone_form_body_phone_val')) {
        if (document.getElementById('raychat_main_container_body_chat_item_message_agent_email_phone_form_body_phone_val').value) {
            if (!raychat_validate_phone(document.getElementById('raychat_main_container_body_chat_item_message_agent_email_phone_form_body_phone_val').value)) {
                document.getElementById('raychat_user_more_details_response').className += " error";
                document.getElementById('raychat_user_more_details_response').classList.remove('success');
                document.getElementById('raychat_user_more_details_response').innerHTML = widget.lang.invalidPhone;
                return false;
            }
            tdata.phone = document.getElementById('raychat_main_container_body_chat_item_message_agent_email_phone_form_body_phone_val').value;
        }
    }

    var raychat_form_tabs = document.getElementsByClassName('raychat_main_container_body_chat_item_message_agent_email_phone_form_tab')
    var shownField = [];

    if (raychat_form_tabs[0]) {

        raychat_form_tabs = raychat_form_tabs[0].getElementsByTagName('li');
        for (var tab = 0; tab <= raychat_form_tabs.length; tab++) {
            if (raychat_form_tabs[tab] && raychat_form_tabs[tab].id) {
                var raychat_this_tab_id = raychat_form_tabs[tab].id.split('_')
                shownField.push(raychat_this_tab_id[raychat_this_tab_id.length - 1])
            }
        }
    }

    tdata.shownField = shownField

    if (!tdata.email && !tdata.phone) return false

    io.socket.post(pubsub + '/socket/userDetail', tdata, function (res) {


        if (res.success) {

            if (!res.user.lockForFillDetails) {
                raychat_avoid_sending(false);


                document.getElementsByClassName('raychat_main_container_footer')[0].removeEventListener('click', scroll_to_form, true);

                document.getElementById('raychat_main_textarea').disabled = false;
                document.getElementById('raychat_main_textarea').placeholder = widget.lang.sendMessage;
                document.getElementById('raychat_main_textarea').focus();
                scrollTo(s, s.scrollHeight, 2000);
            }

            isUserLock = res.user.lockForFillDetails;


            if (res.neededField) {
                if (res.neededField === "phone") {

                    simulatedClick(document.getElementById('raychat_main_container_body_chat_item_message_agent_email_phone_form_tab_phone'))

                } else {
                    simulatedClick(document.getElementById('raychat_main_container_body_chat_item_message_agent_email_phone_form_tab_email'))
                }
            }


            if (document.getElementById('raychat_user_more_details_response')) {
                document.getElementById('raychat_user_more_details_response').className += " success";
                document.getElementById('raychat_user_more_details_response').classList.remove('error');

            }

            if (document.getElementById('raychat_user_more_details_response')) {
                document.getElementById('raychat_user_more_details_response').className += " success";
                document.getElementById('raychat_user_more_details_response').classList.remove('error');
            }


            if (document.getElementById('raychat_main_container_body_chat_item_message_agent_email_phone_form_body_email_val')) {
                if (document.getElementById('raychat_main_container_body_chat_item_message_agent_email_phone_form_body_email_val').value) {
                    document.getElementById('raychat_user_more_details_response').innerHTML = widget.lang.yourDetailsWasSaved;
                    document.getElementById('raychat_main_container_body_chat_item_message_agent_email_phone_form_body_email_val').disabled = true;
                    thisnode.disabled = true;
                }
            }

            if (document.getElementById('raychat_main_container_body_chat_item_message_agent_email_phone_form_body_phone_val')) {
                if (document.getElementById('raychat_main_container_body_chat_item_message_agent_email_phone_form_body_phone_val').value) {
                    document.getElementById('raychat_user_more_details_response').innerHTML = widget.lang.yourDetailsWasSaved;
                    document.getElementById('raychat_main_container_body_chat_item_message_agent_email_phone_form_body_phone_val').disabled = true;
                    thisnode.disabled = true;
                }
            }


            parent.Raychat.__profile_updated(res.user);

        } else {
            document.getElementById('raychat_user_more_details_response').className += " error";
            document.getElementById('raychat_user_more_details_response').classList.remove('success');
            document.getElementById('raychat_user_more_details_response').className += " error";
            document.getElementById('raychat_user_more_details_response').classList.remove('success');

            var invalidAttr = res.data.invalidAttributes;
            if (invalidAttr) {
                if (document.getElementById('raychat_main_container_body_chat_item_message_agent_email_phone_form_body_email_val').value) {
                    if (invalidAttr.email[0].rule == "unique") {
                        document.getElementById('raychat_user_more_details_response').innerHTML = widget.lang.emailAlreadyExist;
                    } else {
                        document.getElementById('raychat_user_more_details_response').innerHTML = widget.lang.invalidEmail;
                    }

                }
                if (document.getElementById('raychat_main_container_body_chat_item_message_agent_email_phone_form_body_phone_val').value) {
                    document.getElementById('raychat_user_more_details_response').innerHTML = widget.lang.thereWas
                }
            }

        }


    });
}



function raychat_send_user_data(thisnode) {


    delete tdata.tmpId;
    delete tdata.href;
    delete tdata.msg;

    tdata.id = raychat_local_storage.getItem("rayToken");

    var shownField = [];




    var nameField = document.getElementById('raychat_main_container_body_chat_item_message_agent_email_phone_form_body_name_val');
    var emailField = document.getElementById('raychat_main_container_body_chat_item_message_agent_email_phone_form_body_email_val');
    var phoneField = document.getElementById('raychat_main_container_body_chat_item_message_agent_email_phone_form_body_phone_val');









    if (nameField) {


        tdata.fullname = nameField.value;
    }


    if (emailField) {
        if (emailField.value) {
            if (!raychat_validate_email(emailField.value)) {
                document.getElementById('raychat_user_more_details_response').className += " error";
                document.getElementById('raychat_user_more_details_response').classList.remove('success');
                document.getElementById('raychat_user_more_details_response').innerHTML = widget.lang.invalidEmail;
                return false;
            }


            tdata.email = emailField.value;

        }
    }
    if (phoneField) {
        if (phoneField.value) {
            if (!raychat_validate_phone(phoneField.value)) {

                document.getElementById('raychat_user_more_details_response').className += " error";
                document.getElementById('raychat_user_more_details_response').classList.remove('success');
                document.getElementById('raychat_user_more_details_response').innerHTML = widget.lang.invalidPhone;
                return false;
            }

            tdata.phone = phoneField.value;
        }
    }














    if (currentForm && currentForm && currentForm.form && JSON.parse(currentForm.form.forceGetUserDetails)) {

        if (currentForm.form.fieldName === "email" && !tdata.email) {

            emailField.focus()
            return false;

        } else if (currentForm.form.fieldName === "name" && !tdata.fullname) {


            nameField.focus()
            return false;

        } else if (currentForm.form.fieldName === "phone" && !tdata.phone) {
            phoneField.focus()
            return false()

        } else if (currentForm.form.fieldName === "both") {


            if (!tdata.email) {
                emailField.focus()
                return false;

            } else if (!tdata.phone) {
                phoneField.focus()
                return false;

            }

        } else if (currentForm.form.fieldName === "allThree") {

            if (!tdata.fullname) {
                nameField.focus()
                return false;

            } else if (!tdata.email) {
                emailField.focus()
                return false;

            } else if (!tdata.phone) {
                phoneField.focus()
                return false;
            }





        }



    }

    if (widget && widget.channel && currentForm && currentForm.form) {

        if (currentForm.form.fieldName === "email") {
            shownField = ['email']


        } else if (currentForm.form.fieldName === "name") {
            shownField = ['fullname']

        } else if (currentForm.form.fieldName === "phone") {
            shownField = ['phone']

        } else if (currentForm.form.fieldName === "both") {
            shownField = ['email', 'phone']

        } else if (currentForm.form.fieldName === "allThree") {
            shownField = ['fullname', 'email', 'phone']
        }



    }



    if (!tdata.email && !tdata.phone && !tdata.fullname) return false



    tdata.shownField = shownField



    io.socket.post(pubsub + '/socket/userDetail', tdata, function (res) {


        if (res.success) {

            if (!res.user.lockForFillDetails) {
                raychat_avoid_sending(false);


                document.getElementsByClassName('raychat_main_container_footer')[0].removeEventListener('click', scroll_to_form, true);

                document.getElementById('raychat_main_textarea').disabled = false;
                document.getElementById('raychat_main_textarea').placeholder = widget.lang.sendMessage;
                document.getElementById('raychat_main_textarea').focus();
                scrollTo(s, s.scrollHeight, 2000);
            }

            isUserLock = res.user.lockForFillDetails;


            if (res.neededField) {
                if (res.neededField === "name") {
                    nameField.focus()
                } else if (res.neededField === "email") {
                    emailField.focus()
                } else {
                    phoneField.focus()
                }
            }


            if (document.getElementById('raychat_user_more_details_response')) {
                document.getElementById('raychat_user_more_details_response').className += " success";
                document.getElementById('raychat_user_more_details_response').classList.remove('error');

            }




            if (emailField) {
                if (emailField.value) {
                    emailField.disabled = true;
                    thisnode.disabled = true;
                }
            }

            if (phoneField) {
                if (phoneField.value) {
                    phoneField.disabled = true;
                    thisnode.disabled = true;
                }
            }

            if (nameField) {
                if (nameField.value) {
                    nameField.disabled = true;
                    thisnode.disabled = true;
                }
            }

            document.getElementById('raychat_user_more_details_response').innerHTML = widget.lang.yourDetailsWasSaved;



            parent.Raychat.__profile_updated(res.user);

        } else {
            document.getElementById('raychat_user_more_details_response').className += " error";
            document.getElementById('raychat_user_more_details_response').classList.remove('success');




            var invalidAttr = res.data.invalidAttributes;
            if (invalidAttr) {
                if (document.getElementById('raychat_main_container_body_chat_item_message_agent_email_phone_form_body_email_val').value) {
                    if (invalidAttr.email[0].rule == "unique") {
                        document.getElementById('raychat_user_more_details_response').innerHTML = widget.lang.emailAlreadyExist;
                    } else {
                        document.getElementById('raychat_user_more_details_response').innerHTML = widget.lang.invalidEmail;
                    }

                }
                if (document.getElementById('raychat_main_container_body_chat_item_message_agent_email_phone_form_body_phone_val').value) {

                    document.getElementById('raychat_user_more_details_response').innerHTML = widget.lang.thereWas
                }
            }

        }


    });
}

function closeAutomessage(id) {
    tdata.id = localStorage.getItem('rayToken')
    io.socket.post(pubsub + '/socket/automessage', {
        action: 'close',
        autoMessageId: id,
        data: tdata
    }, function (resData, jwres) {
        console.log(resData)
        console.log(jwres)
    });
}

function parse_query_string(query) {
    var vars = query.split("&");
    var query_string = {};
    for (var i = 0; i < vars.length; i++) {
        var pair = vars[i].split("=");
        var key = decodeURIComponent(pair[0]);
        var value = decodeURIComponent(pair[1]);
        // If first entry with this name
        if (typeof query_string[key] === "undefined") {
            query_string[key] = decodeURIComponent(value);
            // If second entry with this name
        } else if (typeof query_string[key] === "string") {
            var arr = [query_string[key], decodeURIComponent(value)];
            query_string[key] = arr;
            // If third or later entry with this name
        } else {
            query_string[key].push(decodeURIComponent(value));
        }
    }
    return query_string;
}





function simulatedClick(target, options) {

    var event = target.ownerDocument.createEvent('MouseEvents'),
        options = options || {},
        opts = { // These are the default values, set up for un-modified left clicks
            type: 'click',
            canBubble: true,
            cancelable: true,
            view: target.ownerDocument.defaultView,
            detail: 1,
            screenX: 0, //The coordinates within the entire page
            screenY: 0,
            clientX: 0, //The coordinates within the viewport
            clientY: 0,
            ctrlKey: false,
            altKey: false,
            shiftKey: false,
            metaKey: false, //I *think* 'meta' is 'Cmd/Apple' on Mac, and 'Windows key' on Win. Not sure, though!
            button: 0, //0 = left, 1 = middle, 2 = right
            relatedTarget: null,
        };

    //Merge the options with the defaults
    for (var key in options) {
        if (options.hasOwnProperty(key)) {
            opts[key] = options[key];
        }
    }

    //Pass in the options
    event.initMouseEvent(
        opts.type,
        opts.canBubble,
        opts.cancelable,
        opts.view,
        opts.detail,
        opts.screenX,
        opts.screenY,
        opts.clientX,
        opts.clientY,
        opts.ctrlKey,
        opts.altKey,
        opts.shiftKey,
        opts.metaKey,
        opts.button,
        opts.relatedTarget
    );

    //Fire the event
    target.dispatchEvent(event);
}

function scroll_to_form() {






    scrollTo(s, s.scrollHeight - document.getElementsByClassName('raychat_main_container_body_chat_item_message_agent_email_phone_form')[0].offsetHeight - 280, 300);
}



document.getElementById('raychat_main_textarea').onkeyup = function (e) {



    var val = document.getElementById('raychat_main_textarea').value;
    var lastChar = val.substr(val.length - 1)
    var oneToLast = val.substr(val.length - 2, 1)

    if (oneToLast == " " && e.keyCode == 32) return;





    if (e.keyCode == 32 || (e.keyCode == 8 && lastChar == " " && oneToLast != " ")) {
        io.socket.post(pubsub + '/socket/real', tdata, function (res) { });
    }

};